/**
 * @ngdoc Service
 * @name NetService
 * @description
 *   process almost all net request work, support the publish_car as a public service
 */

AuctionTypein.factory('NetService', function ($http, $ionicPopup) {
	var isOnline = true;
   if(window.h5_is_dev){
     isOnline = false;
   }
	if(isOnline){
		var user_token = "" ;
        Jockey.send('UserBridge', function(data) {
            user_token = data.userToken;
        });
		window.base_url = "http://paimai.souche.com";
        window.dic_api = 'http://dic.souche.com';
		//var user_token = "8ea3a787311d1dbf5c284a2ecac78c47"
	} else {
		var debugVersion = (window.CheNiu && parseInt(CheNiu.whichDebugEnv())) || 0;
		// alert(debugVersion);
		// alert('环境:'+CheNiu.whichDebugEnv());
		if(debugVersion >0 && debugVersion<10){
			window.base_url = "http://test"+debugVersion+".paimaitest.souche.com";
		} else if (debugVersion >10 && debugVersion < 100) {
			window.base_url = "http://sim"+debugVersion+".paimaitest.souche.com";
		} else if (debugVersion >100){
			window.base_url = "http://intra.paimaitest.souche.com";
		} else {
			window.base_url = "http://paimai.souche.com";
		}
//		var niu_url = "http://cheniu-dev.souche.com:8001";
		var user_token =  window.CheNiu && CheNiu.getToken();
        window.dic_api = 'http://dic.souche.com';
	}
    return {
		/**
		 * get the app name, provide by client
		 * @function getAppName
		 * @memberof NetService
		 * @returns {String}  return current app type. eg. cheniu/yihui/yuntong
		 */
		getAppName: function(){
			return (window.CheNiu && CheNiu.getAppId()) || 'cheniu';
		},
		/**
		 * Ajax: Returns the province code and name after ajax
		 * @function getProvince
		 * @memberof NetService
		 * @returns {Hash}  return ajax success or fail result and data.
		 */
        getProvince:function(callback){
            $.ajax({
                url: window.dic_api + '/api/v1/queryDictionaries/load.jsonp?type=area',
                dataType: 'jsonp',
                type: 'get',
                jsonpCallback:"callback",
                success: function(data) {
                    callback(data.data);
                }
            })
        },
		/**
		 * Ajax: Returns the cities code and name after ajax, pass province id
		 * @function getCity
		 * @memberof NetService
		 * @param {Number}  id  province_code
		 * @returns {Hash}  return ajax success or fail result and data.
		 */
        getCity:function(id, callback){
			return $.ajax({
                url: window.dic_api + '/api/v1/queryDictionaries/load.jsonp?type=area&parent=' + id,
                dataType: 'jsonp',
                type: 'get',
                jsonpCallback:"callback",
                success: function(data) {
                    return callback(data.data);
                }
            })
        },

        getCityG:function(id, callback){
            return $.ajax({
                url: window.dic_api + '/api/v1/queryDictionaries/load.jsonp?type=area&parent=' + id,
                dataType: 'jsonp',
                type: 'get',
                jsonpCallback:"callback_2",
                success: function(data) {
                    return callback(data.data);
                }
            })
        },

		/**
		 * Ajax: get current type by token ,is shenzhou or others
		 * @function getAccountType
		 * @memberof NetService
		 * @param {Object} callback the callback function
		 */
		getAccountType: function(callback){
			if(!user_token){
				user_token = window.CheNiu && CheNiu.getToken();
			}
			var token = user_token;
			if(token){
				$.ajax({
					url: encodeURI(base_url+'/api/v5/users/me'),
					data:{
						token: token
					},
					type: 'post',
					success: function(rData){
						if(rData.message === 'OK' && rData.data.current_user){
							callback(rData.data.current_user.authshop_id);
						}
					}

				})
			}
		},

		/**
		 * Ajax: get current user auth: paimai type is real or xianchang
		 * @function getPaiType
		 * @memberof NetService
		 * @param {Object} callback  the callback function
		 */
        getPaiType: function(callback){
			if(!user_token){
				user_token = window.CheNiu && CheNiu.getToken();
			}
            var token = user_token;
            if(token){
                $.ajax({
                    url: encodeURI(base_url+'/api/v5/users/me'),
                    data:{
                        token: token
                    },
                    type: 'post',
                    success: function(rData){
                        if(rData.message === 'OK' && rData.data.current_user){
                            var myAuctionType = rData.data.supported_auction;
                            var myPaiType = 0;
                            switch(myAuctionType){
                                case "realtime":myPaiType=0;break; // 实时拍
                                case "live":myPaiType=1;break; //现场拍
                                case "close":myPaiType=-1;break; // 错误
                                case "both":myPaiType=2;break; // 实时拍 或 现场拍
                            }
                            callback(myPaiType);

                        }
                    }

                })
            }
        },
		/**
		 * Ajax: get commission by exprice price, used by auction_page
		 * @function getCommissionGold
		 * @memberof NetService
		 * @param {Number} price the exprice price ,entering by user.
		 * @param {Object} callback the callback function
		 */
        getCommissionGold:function(price,callback){
			if(!user_token){
				user_token = window.CheNiu && CheNiu.getToken();
			}
            var token = user_token;
            if(token) {
                $.ajax({
                    url: encodeURI(base_url + '/api/v5/auctions/commission'),
                    data: {
                        token: token,
                        target_price: price,
                    }, type: 'get',
                    success: function (rData) {
                        if (rData.message === 'OK') {
                            callback(rData.data);
                        }
                    }
                })
            }
        },

		/**
		 * Ajax: auto price ,currently only used by shenzhou 000139
		 * @function getDelegatePrice
		 * @memberof NetService
		 * @param {Hash} param json inclue car_type, date, detection_level...
		 * @param {Object} callback the callback function
		 */
		getDelegatePrice: function(param, callback){
			if(!user_token){
				user_token = window.CheNiu && CheNiu.getToken();
			}
			var token = user_token;
			if(token){
				param.token = token;
				$.ajax({
					url: encodeURI(base_url+'/api/v5/cars/autoprice'),
					data: param,
					type: 'post',
					success: function(data){
						callback(data)
					}

				})
			}
		},
		/**
		 * convert unit when restore data
		 * @function convertUnitToWan
		 * @memberof NetService
		 * @param {Hash} object the property container, used to put the convert result.
		 * @param {Number} key the origin value, will to be convert
		 */
		convertUnitToWan: function (object, key) {
			if (object && object[key]) {
				object[key] = (object[key]*1)/10000 ;
			}
		},
		/**
		 * conver unit to Yuan when save data
		 * @function convertUnitToYuan
		 * @memberof NetService
		 * @param {Hash} object the property container, used to put the convert result.
		 * @param {Number} key the origin value, will to be convert
		 */
		convertUnitToYuan: function (object, key) {
			if (object && object[key]) {
				object[key] = Math.round(object[key]*10000) ;
			}
		},
		/**
		 * Ajax: key function, save auction car data to server
		 * @function saveToOnline
		 * @memberof NetService
		 * @param {Hash} result this json will include basic/detection/auction data
		 * @param {Object} callback the callback function
		 */
        saveToOnline:function(result,callback){
			if(!user_token){
				user_token = window.CheNiu && CheNiu.getToken();
			}
			var token = user_token;

            result.basic.province_code = result.basic.province_id;
            result.basic.city_code = result.basic.city_id;
            result.basic.attribution_province_code = result.basic.vehicle_attribution_province_id;
            result.basic.attribution_city_code = result.basic.vehicle_attribution_city_id;
            delete result.basic.vehicle_attribution_city;
            delete result.basic.vehicle_attribution_province;
            delete result.basic.province;
            delete result.basic.city;

            $.ajax({
                url:base_url+"/api/v5/cars?token="+token,
                data:{
                    param:JSON.stringify(result)
                },
                type:"post",
                dataType:"json",
                success:function(data){
                    if(data.status==200){
                        callback(null,data)
                    }else{
                        callback(new Error(data.message),data)
                    }
                },
                error:function(e){
                    callback(new Error("网络出错，请稍后重试！"))
                }
            })
        },
		/**
		 * Ajax: key function, restore car data from server
		 * @function restoreFromOnline
		 * @memberof NetService
		 * @param {Number} carId the id whoose data will be restore
		 * @param {Object} callback the callback function
		 */
        restoreFromOnline:function(carId,callback){
			if(!user_token){
				user_token = window.CheNiu && CheNiu.getToken();
			}
           var token = user_token;
            $.ajax({
                url:base_url+"/api/v5/cars/"+carId+"?token="+token,
                type:"get",
                dataType:"json",
                success:function(data){
                    if(data.status==200){
                        data.data.basic.province_id = data.data.basic.province_code;
                        data.data.basic.city_id = data.data.basic.city_code;
                        data.data.basic.vehicle_attribution_province_id = data.data.basic.attribution_province_code;
                        data.data.basic.vehicle_attribution_city_id = data.data.basic.attribution_city_code;
                        callback(null,data)
                    }else{
                        callback(new Error(data.message),data)
                    }

                },
                error:function(e){
                    callback(new Error("网络出错，请稍后重试！"))
                }
            })
        },
		/**
		 * upload pictures, return a json include local_url: online_url //上传图片，返回一个本地url:线上url的json
		 * @function savePics
		 * @memberof NetService
		 * @param {Array} pics the pictures array
		 * @param {Object} callback the callback function
		 */
        savePics:function(pics,callback){
            if((!pics)||(!pics.length)){
                callback({})
                return
            }
            if(window.CheNiu){
                CheNiu.uploadFilesCallback=function(str){
                    var ps = str.split(",")
                    var r = {}
                    ps.forEach(function(p){
                        var s = p.split("=")
                        if(s.length){
                            r[s[0]]=s[1];
                        }
                    })
                    callback(r)
                };
                CheNiu.uploadFiles(pics.join(","))
            }else{
                var obj = {};
                pics.forEach(function(p){
                    obj[p] = ""
                })
                callback(obj)
            }
        },
		/**
		 * after save car data, submit the car to review
		 * @function submitReview
		 * @memberof NetService
		 * @param {Number} carId the id which will be reviewed
		 * @param {Object} callback the callback function
		 */
        submitReview:function(carId,callback){
			if(!user_token){
				user_token = window.CheNiu && CheNiu.getToken();
			}
            var token = user_token;
            $.ajax({
                url:base_url+"/api/v5/cars/"+carId+"/apply?token="+token,
                type:"post",
                dataType:"json",
                success:function(data){
                    if(data.status==200){
                        callback(null,data)
                    }else{
                        callback(new Error(data.message),data)
                    }
                },
                error:function(e){
                    callback(new Error("网络出错，请稍后重试！"))
                }
            })
        },
		/**
		 * fetch car info by vinCode
		 * @function getInfoByVIN
		 * @memberof NetService
		 * @param {String} vin 17位车架识别码 eg. LFV4A24F3B3078582
		 * @param {Object} callback the callback function
		 */
        getInfoByVIN:function(vin,callback){
            //LFV4A24F3B3078582
            $.ajax({
                url:"http://manage.souche.com/pages/vinAction/vin.json?vin="+vin,
                type:"get",
                dataType:"jsonp",
                timeout:5000,
                success:function(data){
                    if(data&&data.length){
                        callback(null,data)
                    }else{
                        callback(new Error("vin格式错误"))
                    }
                },
                error:function(e){
                    callback(new Error("网络出错，请稍后重试！"))
                }
            })
        },
		/**
		 * get configs by model
		 * @function getConfigByModel
		 * @memberof NetService
		 * @param {String} modelCode
		 * @param {Object} callback the callback function
		 */
        getConfigByModel: function(modelCode, callback){
            var url = 'http://42.120.61.109/model/parameter/m/';
            $.ajax({
                url: url + modelCode,
                type:"get",
                dataType:"jsonp",
                timeout:5000,
                success:function(data){
                    if(data&&data.code === 200){
                        callback(null, data.data)
                    }else{
                        var errorMsg = {
                            403: '车型不存在',
                            101: '参数不能为空'
                        };
                        callback(new Error( errorMsg[data.code] || '未知错误'))
                    }
                },
                error:function(e){
                    callback(new Error("网络出错，请稍后重试！"))
                }
            })
        }
    }
});
