(function() {
	var vinMatchCache = {};
	var stopMatchOnce;

	//初始化的时候把秒数转化成date
    var getDateFromSecondTimestamp = function (object, key) {
        if (object[key] && object[key] > 1000000) {
            object[key] = new Date(object[key] * 1000);
        }
    }

    //保存的时候把date转化成秒数
    var getSecondTimestampFromDate = function (object, key) {
        if (object[key] && object[key].getTime) {
            object[key] = object[key].getTime() / 1000
        }
    }
	//uppercase vinCode
	var uppercaseConversion = function(object, key) {
		if (object&&object[key]) {
			object[key] = object[key].toString().toUpperCase();
		}
	}

    function setConfigToScope(configData, scope, transfer){
        // -----------------  基本信息   -------------------------------
        // 新车(指导)价 不含购置税
        scope.carInfo.basic.original_price = configData.priceGuide ? parseFloat((configData.priceGuide/10000).toFixed(2)) : '';
        // 排放标准
		scope.carInfo.basic.environment = configData.emissionStandard&&transfer.getEnvironment(configData.emissionStandard);
        // 排量
        scope.carInfo.basic.engine_capacity = configData.engineVolume * 1 > 0
            ? ((configData.engineVolume / 10).toFixed(1) + ((configData.intakeType * 1 === 1) ? "L" : "T"))
            : '';
		// 进气方式
        scope.carInfo.configuration.inlet = configData.intakeType && transfer.getInletType(configData.intakeType);
		//驱动形式
        scope.carInfo.configuration.drive_form = configData.driveType && transfer.getDrive_form(configData.driveType);
        // 变速形式
        scope.carInfo.configuration.variable_form = configData.gearboxType && transfer.getGearboxType(configData.gearboxType);
        // 车厢
        scope.carInfo.configuration.carriage = (configData.body&&transfer.getBody(configData.body))||'';
        // 供油系统
        scope.carInfo.configuration.supply_system = configData.fuelType&&transfer.getFuelType(configData.fuelType);
        //
        // 配置列表中的数据
        transfer.getConfigList(configData, scope);
        // -----------------  手续信息   -------------------------------
    }

    AuctionTypein.controller('BaseCtrl', function (
        $scope,
        $ionicScrollDelegate,
        $stateParams,
        $ionicModal,
        $ionicLoading,
		$ionicPopup,
        $http,
        $timeout,
		$interval,
		$filter,
        DataService,
        NetService,
		Validator,
		ModelConfigTransfer
        ) {
        Jockey.send("SetRightBar",{
            title:"保存",
            show: 1
        })
        Jockey.send("SetWebViewTitle",{
            title: '基本信息'
        });
        window.rightButtonEvent = function(){
            $scope.saveBasicInfo();
        }

        $scope.tabs = basicInfoData.tabsInfo;
        $scope.currentTab = 'basicInfo';
        $scope.carInfo = {basic: {}, configuration: {}, procedure: {}};
		$scope.carModelText={};
        $scope.provincedb = []
        $scope.provinceVecdb = []
        $scope.vehicleCidydb = [];
        $scope.cidydb = [];
		$scope.isBrand = false;
		$scope.isUsedCar = (parseInt(DataService.carType) === 1); //!
        $scope.openChooser = false;
        $scope.plateLeading = '京';
        $scope.paiType = DataService.paiType;
        $scope.carType = DataService.carType;
		$scope.shopName = NetService.getAppName();
        $scope.carInfo = DataService.getBasicData().data;
		$scope.price_o = {};
        $scope.plate = {};
		var realSaveId = null;
		if ($scope.carInfo.basic) {
            getDateFromSecondTimestamp($scope.carInfo.basic, 'begin_at')
            getDateFromSecondTimestamp($scope.carInfo.basic, 'manufacture_date')
//			NetService.convertUnitToWan($scope.carInfo.basic, 'mileage');
//			NetService.convertUnitToWan($scope.carInfo.basic, 'original_price');

		}
        if ($scope.carInfo.procedure) {
            $scope.carInfo.procedure.purchase_tax = $scope.carInfo.procedure.purchase_tax ? $scope.carInfo.procedure.purchase_tax + "" : "";
            $scope.carInfo.procedure.affort_handling_fee = $scope.carInfo.procedure.affort_handling_fee ? $scope.carInfo.procedure.affort_handling_fee + "" : "";
            getDateFromSecondTimestamp($scope.carInfo.procedure, 'year_insurance')
            getDateFromSecondTimestamp($scope.carInfo.procedure, 'compulsory_insurance')
            getDateFromSecondTimestamp($scope.carInfo.procedure, 'travel_tax_due_date')
            getDateFromSecondTimestamp($scope.carInfo.procedure, 'business_insurance')
            getDateFromSecondTimestamp($scope.carInfo.procedure, 'transferred_at')

        }

        // 如果是"编辑车辆" 且vin码已填写, 就阻止在进入这个route的时候立即匹配
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
            // alert(JSON.stringify($scope.carInfo));
            if($scope.carInfo.basic && $scope.carInfo.basic.vin_code && $scope.carInfo.basic.vin_code.length == 17){
                stopMatchOnce = true;
            }
            else{
                stopMatchOnce = false;
            }

            

            $scope.isBasicInfoIncomplete = DataService.getBasicData().type_count > 0 && (DataService.getBasicData().type_count < DataService.getBasicData().total_count);
        });

        $timeout(function () {
            // if ($scope.carInfo && $scope.carInfo.basic && $scope.carInfo.basic.vehicle_attribution_province_id)
            //     $scope.carInfo.basic.vehicle_attribution_province_id = $scope.carInfo.basic.vehicle_attribution_province_id * 1
            // if ($scope.carInf>o && $scope.carInfo.basic && $scope.carInfo.basic.vehicle_attribution_city_id)
            //     $scope.carInfo.basic.vehicle_attribution_city_id = $scope.carInfo.basic.vehicle_attribution_city_id * 1

            // if ($scope.carInfo && $scope.carInfo.basic && $scope.carInfo.basic.province_id)
            //     $scope.carInfo.basic.province_id = $scope.carInfo.basic.province_id * 1
            // if ($scope.carInfo && $scope.carInfo.basic && $scope.carInfo.basic.city_id)
            //     $scope.carInfo.basic.city_id = $scope.carInfo.basic.city_id * 1
			if($scope.carInfo.procedure && $scope.shopName === 'yihui') {
				if($scope.carInfo.procedure.cost_price){
					DataService.setPriceData($scope.carInfo.procedure.cost_price);
				} else {
					$scope.carInfo.procedure.cost_price = {};
				}
			}
        }, 0, false);
        NetService.getProvince(function(data){
                $scope.provinceVecdb = data;
                $scope.provincedb = data;
                if ($scope.carInfo.basic && $scope.carInfo.basic.province_id) {
                    NetService.getCityG($scope.carInfo.basic.province_id, function (data) {
                       $scope.cidydb = data;
                    })
                }

                if ($scope.carInfo.basic && $scope.carInfo.basic.vehicle_attribution_province_id) {
                    NetService.getCity($scope.carInfo.basic.vehicle_attribution_province_id, function (data) {
                       $scope.vehicleCidydb =  data;
                    })
                }
                // $scope.getCity();
                // $scope.getCityG();
		})
//			.success(function(response) {
//            if (response.message === "OK") {
//                $scope.provinceVecdb = response.data;
//                $scope.provincedb = response.data;
//                $scope.getCity();
//                $scope.getCityG();
//            }
//        })
if ($scope.carInfo.basic && $scope.carInfo.basic.license_number) {
    console.log($scope.carInfo.basic.license_number)
                var str = $scope.carInfo.basic.license_number;
                $scope.plate.plateLeading = str.slice(0, 1);
                $scope.plate.license_appending = str.slice(1);
                console.log($scope.plate.plateLeading)
            }
        $timeout(function () {
			var url = 'http://42.120.61.109/model' ;
			$http.jsonp(url + '?callback=getCarBrand');
        }, 200)

        $scope.toggleChooser = function() {
            $scope.openChooser = !$scope.openChooser;
        }

        $scope.selectPlateLeading = function(letter) {
            $scope.plate.plateLeading = letter;
            $scope.openChooser = false;
            $scope.updateLicense();
        }
        $scope.$watch('carInfo.basic.vehicle_attribution_province_id', function() {
            var letters = {"03095":"新","00530":"辽","00001":"京","01840":"湘","02914":"甘","00105":"冀","00419":"蒙","00043":"津","02245":"琼","01193":"闽","02799":"陕","00974":"浙","02272":"川","02718":"藏","02474":"贵","02572":"云","00021":"沪","00289":"晋","01288":"赣","02122":"桂","00714":"黑","03066":"宁","00858":"苏","01075":"皖","00644":"吉","01725":"鄂","00063":"渝","01398":"鲁","01556":"豫","03014":"青","01977":"粤"};
            if ($scope.carInfo.basic && $scope.carInfo.basic.vehicle_attribution_province_id) {
                var find = letters[$scope.carInfo.basic.vehicle_attribution_province_id];
                if(find){
                    $scope.plate.plateLeading = find
                $scope.carInfo.basic.license_number = ($scope.plate.plateLeading || '') + ($scope.plate.license_appending || '');
                }
                 
            }
        })

        $scope.updateLicense = function(license_appending) {
            if ($scope.plate.license_appending && $scope.plate.license_appending.length >= 6) {
                $scope.plate.license_appending = $scope.plate.license_appending.slice(0, 6);
            }
            $scope.carInfo.basic.license_number = ($scope.plate.plateLeading || '') + ($scope.plate.license_appending || '');

        }

        $scope.$watch('carInfo.basic.license_number', function() {
            // WTF?
            // if ($scope.carInfo.basic && $scope.carInfo.basic.license_number && $scope.carInfo.basic.license_number !== 'undefined' ) {
            //     $scope.plate.plateLeading = $scope.carInfo.basic.license_number.slice(0, 1);
            //     $scope.plate.license_appending = $scope.carInfo.basic.license_number.slice(1);
            // }
        })

        $scope.getCity = function () {
            if ($scope.carInfo.basic && $scope.carInfo.basic.vehicle_attribution_province_id)
                NetService.getCity($scope.carInfo.basic.vehicle_attribution_province_id, function (data) {
                   $scope.vehicleCidydb =  data;
                })
        }
        $scope.getCityG = function () {
            if ($scope.carInfo.basic && $scope.carInfo.basic.province_id)
                NetService.getCityG($scope.carInfo.basic.province_id, function (data) {
                   $scope.cidydb = data;
                })
        }
        $scope.getSeries = function (type) {
            if ($scope.tmpCarModelData.brand_code) {
                var url ='http://42.120.61.109/model/b/';
                $http.jsonp(url + $scope.tmpCarModelData.brand_code + '?callback=getSeriesByBrand');
            }
            if(type){
                $scope.isSeries = true;
                $scope.isModel = false;
            }
        }
        $scope.getModels = function (type) {
            if ($scope.tmpCarModelData.series_code) {
                var url  ='http://42.120.61.109/model/s/' ;
                $http.jsonp(url + $scope.tmpCarModelData.series_code + '?callback=getModelsBySeries');
            }
            if(type){
                $scope.isModel = true;
				$scope.carModelText.searchText = '';
            }
        }


        //}
        $scope.changeDate = function (key, value) {
            $scope.carInfo.basic[key] = value / 1000;  //second as unit ,sync with ruby
        }
        $scope.changeDateProcedure = function (key, value) {
            $scope.carInfo.procedure[key] = value / 1000;  //second as unit ,sync with ruby
        }
        $scope.switchTab = function (index, e) {
            $scope.currentTab = $scope.tabs[index].name;
            $ionicScrollDelegate.scrollTop();
        }
		$scope.chooseBrand = function(){
			$scope.isBrand = true;
		}
        $scope.chooseBrandHide = function(){
            $scope.isBrand = false;
        }
		$scope.closeBrandModal = function(){
			$timeout(function(){
			$scope.isBrand = false;
			$scope.isSeries = false;
			$scope.isModel = false;}, 400)
		}

        // 选定品牌/车系 不去设置最终的数据, 选定车型才设定
        // 先存在临时变量里
        $scope.tmpCarModelData = {};
        $scope.setBrand = function(brand){
            $scope.tmpCarModelData.brand = brand.name;
            $scope.tmpCarModelData.brand_code = brand.code;
        }
		$scope.setSeries = function(series,key){
			$scope.tmpCarModelData.series = series.name;
			$scope.tmpCarModelData.series_code = series.code;
			$scope.tmpCarModelData.series_label = key;
		}
        $scope.setModel = function(model){
			// 选定车型 才把数据写入到scope的basic信息中
			for(var key in $scope.tmpCarModelData){
				$scope.carInfo.basic[key] = $scope.tmpCarModelData[key];
			}
            $scope.carInfo.basic.model = model.name;
            $scope.carInfo.basic.model_code = model.code;

			$ionicLoading.show({ template: '正在通过车型获取配置' });
			$timeout(function(){
				$ionicLoading.hide();
			}, 5000);
			NetService.getConfigByModel(model.code, function(err, data){
				if(!err && data){
					setConfigToScope(data, $scope, ModelConfigTransfer);
				}
				else{
					$ionicLoading.show({ template: '获取配置失败, 请手工填写' });
				}
				$timeout(function(){
					$ionicLoading.hide();
				}, 1000);
			});
		}
		$scope.analyzeData = function(data, conditional) {
			var obj = {};
			for (var i = 0; i < data.length; i++) {
				if (!obj[data[i][conditional]]) {
					obj[data[i][conditional]] = [];
				}
				obj[data[i][conditional]].push(data[i]);
			}
			return obj;
		}
        window.getCarBrand = function (data) {
            if (data.msg == 'successful') {
                $scope.brandDb = $scope.analyzeData(data.data, 'initialsLetter');
            }
            $scope.getSeries();
            $scope.getModels();
        }
        window.getSeriesByBrand = function (data) {
            if (data.msg == 'successful') {
                $scope.seriesDb = $scope.analyzeData(data.data, 'subBrandName');
            }
        }
        window.getModelsBySeries = function (data) {
            if (data.msg == 'successful') {
                $scope.modelsDb = data.data;
            }
        }
		window.getZSPrice = function(data){
			if(data && data.status==="OK") {
				var res = data.zsPrice;
				$scope.carInfo.procedure = $scope.carInfo.procedure || {'cost_price':{}};
				if (res != null) {
//					$scope.price_o.isExist = true;
					$scope.carInfo.procedure.cost_price.purchase = res.fpurcost;
					$scope.carInfo.procedure.cost_price.reconditioning = res.freadinesscost;
				} else {
					$scope.carInfo.procedure.cost_price.purchase = null;
					$scope.carInfo.procedure.cost_price.reconditioning = null;
				}
			} else {
				console.log('获取财务保留价失败')
			}
		}

        //本地发生编辑行为
        $scope.hasChangeBasicInfo = false;
        //延时绑定值变化函数
		$timeout(function() {
            $scope.$watch("carInfo", function () {
                $scope.hasChangeBasicInfo = true;
            }, true)
			//save real time
			if(realSaveId === null){
				realSaveId = $interval(function(){
					var carInfo = $.extend(true,{},$scope.carInfo)// = $.extends(true,{},$scope.carInfo);
					$scope.doSaveOps(carInfo);
				}, 10000);
			}
        }, 1000)
		$scope.doSaveOps = function(carInfo){
			if (carInfo.basic) {
				getSecondTimestampFromDate(carInfo.basic, 'begin_at')
				getSecondTimestampFromDate(carInfo.basic, 'manufacture_date')
				uppercaseConversion(carInfo.basic, 'vin_code');
			}
			if (carInfo.procedure) {
				getSecondTimestampFromDate(carInfo.procedure, 'year_insurance')
				getSecondTimestampFromDate(carInfo.procedure, 'compulsory_insurance')
				getSecondTimestampFromDate(carInfo.procedure, 'travel_tax_due_date')
				getSecondTimestampFromDate(carInfo.procedure, 'business_insurance')
				getSecondTimestampFromDate(carInfo.procedure, 'transferred_at')

				if(carInfo.procedure.transfer_number*1 ===0) {
					delete carInfo.procedure.transferred_at;
				}

				if (carInfo.procedure.where_to) {
					var whereTo = carInfo.procedure.where_to;
					var whereLength = DataService.getObjectLength(carInfo.procedure.where_to_desc);
					var ignoreCount = 0;
					if (whereTo === 'local') {
						if (whereLength != 1 && carInfo.procedure.where_to_desc) {
							delete carInfo.procedure.where_to_desc.affort_shipping_fee;
							delete carInfo.procedure.where_to_desc.affort_mention_fee;
						}
					} else if (whereTo === 'non_local') {
						if (carInfo.procedure.where_to_desc && carInfo.procedure.where_to_desc.transfer_fee) {
							 delete carInfo.procedure.where_to_desc.transfer_fee;
						}
					} else {
						if (whereLength != 3) ignoreCount++;
					}
				}
			}

			DataService.setBasicData(carInfo);
		};

		// save basciInfo, real save when click btn
        $scope.saveBasicInfo = function () {
			if($scope.carInfo.procedure && $scope.shopName === 'yihui' && $scope.carInfo.procedure.cost_price) {
				DataService.setPriceData($scope.carInfo.procedure.cost_price);
				console.log('cost_price: ',$scope.carInfo.procedure.cost_price)
			}
			if(realSaveId !== null){
				$interval.cancel(realSaveId);
				realSaveId = null;
			}
			var result = $.extend(true,{},$scope.carInfo);
			console.log(result);
			if (result.basic) {
				// 校验基本信息
				// 中的 出厂日期,初登日期
				var vBasicResult = Validator.pubCarBase(result.basic);
				if(vBasicResult != true){
					var errMsg = vBasicResult.map(function(item, index){
						return (index+1) + '. ' + item;
					}).join('<br>');
					$ionicPopup.show({
						title: '录入信息有如下错误:',
						subTitle: errMsg,
						scope: $scope,
						buttons: [
							{
								text: '确定',
								type: 'button-positive theme-bg theme-color',
								onTap: function (e) {
									return false;
								}
							},
						]
					});
					return;
				}
			}
			$timeout(function () {
				$scope.doSaveOps($scope.carInfo);
				$scope.hasChangeBasicInfo = false;
				window.history.go(-1);
            }, 0, false);
		}
		//通过vin码匹配车型
       $scope.$watch("carInfo.basic.vin_code",function(){
            if($scope.carInfo.basic.vin_code&&$scope.carInfo.basic.vin_code.length==17){
                if(stopMatchOnce){
                    stopMatchOnce = false;
                    return;
                }
                if( vinMatchCache[$scope.carInfo.basic.vin_code] ){
                    $scope.showModalRecommand(vinMatchCache[$scope.carInfo.basic.vin_code]);
                    return;
                }
                $ionicLoading.show({
                  template: '正在通过Vin码匹配车型数据'
                });
                NetService.getInfoByVIN($scope.carInfo.basic.vin_code,function(error,models){
                    if(!error){
                        if(isUsableVinData(models)){
                            vinMatchCache[$scope.carInfo.basic.vin_code] = models;
                            $scope.showModalRecommand(models);
                            $ionicLoading.hide();
                            return;
                        }
                        else{
                            $ionicLoading.show({
                              template: '匹配失败... 请你手动选择车型'
                            });
                        }
                    }
                    else{
                        $ionicLoading.show({
                          template: '获取失败... 请你手动选择车型'
                        });
                    }
                    $timeout(function(){
                        $ionicLoading.hide();
                    }, 1000);
                })
				if($scope.shopName === 'yihui'){
					$http.jsonp('http://121.40.136.62:9009/online/crawler/price?vimNum=' + $scope.carInfo.basic.vin_code + '&callback=getZSPrice');
				}
            }

		})


		// ---------------------------  根据vin查询并推荐选择 ------------------------
		$scope.showModalRecommand = function(vinModelInfo){
			$scope.vinMatchedModels = vinModelInfo.map(function(m){
				return {
					name: m.soucheModel
					// brand: m.soucheBrandCode, // series: m.soucheSeriesCode,  // model: m.soucheModelCode
				}
			});
			$scope.recModal = $ionicModal.fromTemplate($('#model-rec-by-vin').html(),{
				scope: $scope,
				animation: 'slide-in-up'
			});
            $scope.matched = {
                index: ''
            }
			$scope.recModal.show();
		};
		$scope.chooseMatchedModel = function($index){
            $index = $index||0;
            if ($index === 'no') {
                $scope.recModal.hide().then(function(){
                    $scope.recModal.remove();
                });
                return;
            }
			$scope.recModal.hide().then(function(){
				$scope.recModal.remove();
			});
			var vin = $scope.carInfo.basic.vin_code;
            console.log(vinMatchCache)
			var selectedModel = vinMatchCache[vin][$index];
			// 填充车型车系数据
			$scope.carInfo.basic = {
				vin_code: vin,
				brand: selectedModel.soucheBrand,
				brand_code: selectedModel.soucheBrandCode,
				series: selectedModel.soucheSeries,
				series_code: selectedModel.soucheSeriesCode,
				series_label: selectedModel.manufacturer,
				model: selectedModel.soucheModel,
				model_code: selectedModel.soucheModelCode,
			};
			$ionicLoading.show({ template: '正在通过车型获取配置' });
			$timeout(function(){
				$ionicLoading.hide();
			}, 5000);
			NetService.getConfigByModel(selectedModel.soucheModelCode, function(err, data){
				if(!err && data){
					setConfigToScope(data, $scope, ModelConfigTransfer);
				}
				else{
					$ionicLoading.show({ template: '获取配置失败, 请手工填写' });
				}

				$timeout(function(){
					$ionicLoading.hide();
				}, 1000);
			});
		};
		$scope.fillManually = function(){
			$scope.recModal.hide();
		};
		// --------------------------- endof 通过vin码匹配车型 并推荐选择 ------------------------

//		})
	});

function isUsableVinData(vinModelInfo){
    return vinModelInfo.every(function(m){
        return (m.soucheModel && m.soucheBrandCode && m.soucheSeriesCode && m.soucheModelCode);
    });
}


})();
