(function(){
    var DeDa = detectionData;

    if(!Array.isArray) {
        Array.isArray = function(arg) {
            return Object.prototype.toString.call(arg) === '[object Array]';
        };
    }

    function isNormal(curVal, defaultVal){
        return (curVal == undefined) || (curVal == defaultVal);
    }

    function consDectItems(tabName){
        var items = DeDa.getItems(tabName);
        items.forEach(function(item, index){
            var itemVal = detectStore.getItem(tabName, index);
            if(Array.isArray(itemVal.selected)){
                item.curVal = itemVal.selected.join(' ');
            }
            // else{
            //     item.curVal = itemVal;
            // }
            item.abnormal = !isNormal(item.curVal, item.defaultVal);

            item.other = itemVal.other;
        });
        return items;
    }

    function avoidImgLoadJump(){
        $('.pic-ctn').css(hided);
        setTimeout(function(){
            var img = $('.pic-ctn img');
            if( img.length <= 0){
                return;
            }
            if(img.get(0).complete == true){
                $('.pic-ctn').css(show);
            }
            else{
                img.on('load', function(){
                    $('.pic-ctn').css(show);
                    $(this).unbind('load');
                });
            }
        }, 10);
    }

    var hided = {
        opacity: 0,
        transition: 'opacity ease 0ms'
    };
    var show = {
        opacity: 1,
        transition: 'opacity ease 200ms'
    }

    function getScope(scopeObj, tabName){
        $('.remark-input').unbind('change');
        scopeObj.detectItems = consDectItems( tabName );
        scopeObj.pic = DeDa.getPic( tabName );
        scopeObj.groups = DeDa.getGroups( tabName );
        scopeObj.remark = DeDa.getRemark(tabName);

        if(scopeObj.remark){
            scopeObj.remarkText = detectStore.getRemark(tabName);

            setTimeout(function(){
                // 非实时, blur时才触发
                $('.remark-input').on('change', function(){
                    // console.log(this.value)
                    scopeObj.remarkText = this.value;
                    detectStore.saveRemark(tabName, this.value);
					console.log('save remark')
                });
            }, 0);
        }
    }
    AuctionTypein.controller('DetectionTypeinCtrl',
        function(
            $scope,
            $rootScope,
            $ionicScrollDelegate,
            $ionicPopup,
            DetectSelectService,
			LevelStoreService,
            DataService
        ){
            Jockey.send("SetRightBar",{
                title:"完成",
                show: 1
            })
            Jockey.send("SetWebViewTitle",{
                title: '检测信息'
            });
            window.rightButtonEvent = function(){
                $scope.saveTypein();
                if($scope.is_zhibao){
                    $scope.getZhibaoRank(function(){
                        window.history.go(-1);
                    });
                }else{
                    window.location.href="#/detection-level"
                }
                // window.location.href="#/detection-level"
            }
		DeDa.setData(DataService.version);
        $scope.tabs = DeDa.getTabs();
        detectStore.importData(DataService.detection_data, $scope.tabs);
        DetectSelectService.init($scope);
        $scope.is_zhibao = DataService.is_zhibao;
        $scope.currentTab = $scope.tabs[0].name;
        $scope.sthModified = false;
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
            // 页面切换到这里 就说明上次做的更改已经保存了
            // 将 "有东西修改了" 置为false
            $scope.sthModified = false;

        });
            $rootScope.$on('$stateChangeStart',
                function (event, toState, toParams, fromState, fromParams) {
                    if (toState.name.indexOf("/detection/")!=-1) {
                        Jockey.send("SetRightBar",{
                            title:"完成",
                            show: 1
                        })
                        Jockey.send("SetWebViewTitle",{
                            title: '检测信息'
                        });
                        window.rightButtonEvent = function(){
                            $scope.saveTypein();
                            if($scope.is_zhibao){
                                $scope.getZhibaoRank(function(){
                                    window.history.go(-1);
                                });
                            }else{
                                window.location.href="#/detection-level"
                            }

                        }
                    }else{
                        // window.GoBackEvent = null;
                    }

                })

        getScope($scope, $scope.currentTab);
        avoidImgLoadJump();

        $scope.switchTab = function(index,e){
            avoidImgLoadJump();

            var lastTab = $('.tab-item.active').attr('data-tabname');
            var newTab = $scope.tabs[index].name;
            if(lastTab !== newTab){
                $scope.currentTab = newTab;
                // console.time('change tab, re-get data');
                getScope($scope, newTab);
                // console.timeEnd('change tab, re-get data');
            }

            $ionicScrollDelegate.scrollTop();
        };

        $scope.editOption = function($index){
            var item = DeDa.getItem($scope.currentTab, $index);
            var itemVal = detectStore.getItem($scope.currentTab, $index);

            $('.remark-input').addClass('novisible');

            DetectSelectService.show({
                scope: $scope,
                // name要附带索引号
                title: ($index+1)+'.'+item.name,
                items:item.options,
                abnormalPicRequired: DeDa.isAbnormalPicRequired($scope.currentTab, $index),

                selected: itemVal.selected,
                pictures: itemVal.pictures,
                other: itemVal.other
            },function(selected, pictures, other){
                setTimeout(function(){
                    $('.remark-input').removeClass('novisible');
                }, 500);
                $scope.sthModified = true;

                if(selected.length <= 0 && !other){
                    return;
                }
                var item = $scope.detectItems[$index];
                item.curVal = selected.join(' ');
                item.other = other;
                item.abnormal = !isNormal(item.curVal, item.defaultVal);
                $scope.detectItems[$index] = item;

                // $scope.$digest();

                var dataToSave = {
                    selected: selected,
                    // length为0 就直接传undefined
                    pictures: (pictures.length>0)? pictures : undefined,
                    other: other
                };
                detectStore.saveItem($scope.currentTab, $index, dataToSave);
				$scope.saveTypein();
			});
        };
		$scope.getDetectionLevelRank = function(callback){
			LevelStoreService.getLevelDefine(function(defineData){
				if(DataService.detection_data) {
					LevelStoreService.getCurrentLevel(JSON.stringify(DataService.detection_data), function(res){
						if(res.message === "OK"){
							$scope.rankLevel = res.data.rank + res.data.cost; //should get rank level from the server;
							LevelStoreService.setLevel('ranks', res.data.rank);
							LevelStoreService.setLevel('costs', res.data.cost);
							$scope.levelDefineData = LevelStoreService.consLevelData(defineData, LevelStoreService);
							$scope.remark = LevelStoreService.getRemark() || '';
							var myPopup = $ionicPopup.show({
								title: '根据您修改的内容，系统自动评级为<span class="assertive">'+ $scope.rankLevel+'</span>，请仔细核对您的检测评级',
								scope: $scope,
								buttons: [
									{
										text: '立即核查',
										type: 'button-positive theme-bg theme-border theme-color',
										onTap: function(e) {
											location.href = "#/detection-level";
										}
									}
//									{
//										text: '确定',
//										type: 'button-positive theme-bg theme-border',
//										onTap: function(e) {
//											window.history.go(-1);
//										}
//									}
								]
							});
						} else {
							$debug.error('获取质检等级失败：',res.error);
						}
					})
				}
			});
		};
        // "保存"的事件处理, 将未填写的所有项置为默认值, 保存
        $scope.saveTypein = function(){


			setTimeout(function(){
				detectStore.setRestNormal();
                console.log(detectStore.exportData())
				DataService.setDetectData( detectStore.exportData() );
//				$scope.getDetectionLevelRank()
			},10)



            // console.log(DataService.detection_data);
        };
        // "返回"的事件处理, 将未填写的所有项置为默认值, 保存
        $scope.goBackSaveTypein = function(){
			detectStore.setRestNormal();
            if($scope.sthModified){
                DataService.setDetectData( detectStore.exportData() );
            }else{

            }
			
			LevelStoreService.importData(DataService.detection_data);
			if(LevelStoreService.getLevel('ranks') && $scope.sthModified){
				setTimeout(function(){
					$scope.getDetectionLevelRank()
				},10)
			} else {
//				$scope.getDetectionLevelRank();
				window.history.go(-1);
			}
            // console.log(DataService.detection_data);
        };

            $scope.getZhibaoRank =  function(callback){
                var DeData = DataService.detection_data;
                if(DeData) {
                    LevelStoreService.getCurrentLevel(JSON.stringify(DeData), function(res){
                        if(res.success){

                            DataService.setLevelData({
                                zhibao_rank:res.data.guarantee.rank+res.data.guarantee.cost
                            });
                            $scope.$digest();
                        } else {
                            $debug.error('获取质检等级失败：',res.error);
                        }
                        
                        callback();
                    })
                }else{
                    callback();
                }

            }

    });
})();