// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
/** @ngdoc Index */
angular.module('ngIOS9UIWebViewPatch', ['ng']).config(function($provide) {
  $provide.decorator('$browser', ['$delegate', '$window', function($delegate, $window) {

    if (isIOS9UIWebView($window.navigator.userAgent)) {
      return applyIOS9Shim($delegate);
    }

    return $delegate;

    function isIOS9UIWebView(userAgent) {
      return /(iPhone|iPad|iPod).* OS 9_\d/.test(userAgent) && !/Version\/9\./.test(userAgent);
    }

    function applyIOS9Shim(browser) {
      var pendingLocationUrl = null;
      var originalUrlFn= browser.url;

      browser.url = function() {
        if (arguments.length) {
          pendingLocationUrl = arguments[0];
          return originalUrlFn.apply(browser, arguments);
        }

        return pendingLocationUrl || originalUrlFn.apply(browser, arguments);
      };

      window.addEventListener('popstate', clearPendingLocationUrl, false);
      window.addEventListener('hashchange', clearPendingLocationUrl, false);

      function clearPendingLocationUrl() {
        pendingLocationUrl = null;
      }

      return browser;
    }
  }]);
});
/** @module AuctionTypein */
var AuctionTypein = angular.module('AuctionTypein', ['ionic',"binnng/debug",'ngIOS9UIWebViewPatch'])

/** will be module:AuctionTypein~config */
AuctionTypein.config(function($controllerProvider, $compileProvider, $filterProvider, $provide)
{
    AuctionTypein.controllerProvider = $controllerProvider;
    AuctionTypein.compileProvider    = $compileProvider;
    AuctionTypein.filterProvider     = $filterProvider;
    AuctionTypein.provide            = $provide;
    AuctionTypein.loadDeps = function(deps){
        return function($q, $rootScope)
        {
            var deferred = $q.defer();
            var dependencies =deps;
            $script(dependencies, function()
            {
                // all dependencies have now been loaded by $script.js so resolve the promise
                $rootScope.$apply(function()
                {
                    deferred.resolve();
                });
            });

            return deferred.promise;
        }
    }
    // Register routes with the $routeProvider
})

AuctionTypein.run(function($ionicPlatform) {
        $ionicPlatform.ready(function() {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs).
            // The reason we default this to hidden is that native apps don't usually show an accessory bar, at
            // least on iOS. It's a dead giveaway that an app is using a Web View. However, it's sometimes
            // useful especially with forms, though we would prefer giving the user a little more room
            // to interact with the app.
    if(window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if(window.StatusBar) {
      // Set the statusbar to use the default style, tweak this to
      // remove the status bar on iOS or change it to use white instead of dark colors.
      StatusBar.styleDefault();
    }
  });
});

var UserInfo = {
    token:""
}
Jockey.send('UserBridge', function(data) {
    UserInfo.token = data.userToken;
});
window.rightButtonEvent = function(){

}
Jockey.on("RightBarEvent", function(payload, complete) {
    window.rightButtonEvent();
});


window.GoBackEvent = function(){
    return {goback:1}
};



Jockey.on("GoBackEvent", function(payload, complete) {
        if(!window.GoBackEvent){
        complete({goback:1})
    }else{
        complete(window.GoBackEvent());
    }
});