(function(){
    var newData = {
        'head': detection_data_head,
        'left': detection_data_left,
        'tail': detection_data_tail,
        'right': detection_data_right,
        'mechine': detection_data_mechine,
        'appliance': detection_data_appliance
    };

	var data = newData;
    window.detectionData = {
		_version: 5,
		setData: function(version){
			data = newData;
			this._version = version;
		},

        getTabs: function(){
            var tabs = [];
            for(var i in data){
                tabs.push({
                    text: data[i].text,
                    name: i
                });
                // abnormalPicRequied: data[i].abnormalPicRequied
            }
            return tabs;
        },
        isAbnormalPicRequired: function(tabName, index){
            var groups = window.detectionData.getGroups(tabName);
            if(groups){
                var whichGroup;
                groups.forEach(function(g){
                    if(g.items.indexOf(index) >= 0){
                        whichGroup = g;
                    }
                });
                return whichGroup? whichGroup.abnormalPicRequied : false;
            }
            else{
                return !!data[tabName].abnormalPicRequied;
            }
        },
        getGroups: function(tabName){
            return data[tabName].groups;
        },
        getRemark: function(tabName){
            return data[tabName].remark;
        },
        // 从数据仓库中根据tab名称 提取全部测试项
        getItems: function(tabName){
            var tabData = data[tabName];
            var coords = tabData.coords;
            return tabData.items.map(function(item, index){
                var item = {
                    name: item.name,
                    defaultVal: item.options[0],
                    dataKey: tabData.dataKeys[index]
                };
                if(tabData.pic){
                    // 需要照顾"可点击面积"
                    // 18的圆点  30的可点击
                    item.pos ={
                        left: parseInt(coords[index].x/2)-(30-18)/2,
                        top: parseInt(coords[index].y/2)-(30-18)/2
                    };
                }
                return item;
            });
        },
        // // 从数据仓库中根据tab名称 提取图片名称
        getPic: function(tabName){
            return data[tabName].pic;
        },
        // 从数据仓库中根据tab名称 和 索引号 提取单个测试项的详细数据
        getItem: function(tabName, index){
            // name, options, dataKey
            return data[tabName].items[index];
        },
        isItemHasUnit: function(itemDefaultVal){//根据这里判断是否需要其他other项
            return itemDefaultVal.indexOf('正常') === -1;
        },
		isNewVersion: function(){//根据这里判断是否有'/'
            return this._version >=5;
        }
    },

	window.basicInfoData = {
		tabsInfo: [
			{text: '基本信息', name: 'basicInfo'},
			{text: '配置信息', name: 'configInfo'},
			{text: '手续信息', name: 'procedureInfo'}
		],
		usedCarLabels: ['color_changed','begin_at','vehicle_attribution_province','vehicle_attribution_city','vehicle_attribution_province_id','vehicle_attribution_city_id','license_number','car_nature','use_nature','is_modification']

    }

})()
