(function(){
    // 从localStorage中读取数据
    var storeStr = window.localStorage['detect'];
    var detectStoreData;
    if(storeStr){
        detectStoreData = JSON.parse(storeStr);
    }
    else{
        detectStoreData = {};
    }

    function isEmptyObj(obj){
        for(var i in obj){
            return false;
        }
        return true;
    }

//    // 某些特殊的检测项这么处理, 生成detection
//    // 无漏油/无异响/无蓝烟/无改装   ->  无漏油&|&##异响&|&无蓝烟&|&##改装
    function consUnitItemVal(item, itemSelected){
        var defaultItems = item.defaultVal.split('/');
        return defaultItems.filter(function(di){
			return di!='';
		}).map(function(di){
            var diStr =detectionData.isNewVersion() ? (di.replace(/无/g,"有")) : di.substr(1) ;
            if(itemSelected.indexOf(diStr) >= 0 ){
					return '##'+diStr;
            }
            return di;
        }).sort().join('&|&');
    }
	//所有故障项前都加##
    function consFaultItemVal(item, itemSelected){
        return itemSelected.map(function(di){
                return '##'+di;
        }).join('&|&');
    }
    // 解析特殊的server数据
    function deconsUnitItemVal(itemServerData, item){
		var serverResultItems = itemServerData.detection.split('&|&');
		return serverResultItems.map(function(si){
			return si.replace('##', '');
		});
    }

    // 数据结构: 六个tab + remarks
    // 可以直接根据 detectionData来读取

    window.detectStore = {
        getAll: function(){
            return detectStoreData;
        },
        getTab: function(tabName){
            return detectStoreData[tabName];
        },
        getItem: function(tabName, index){
            var tabData = detectStoreData[tabName] || [];
            return tabData[index] || {};
        },
        getRemark: function(tabName){
            detectStoreData.remarks = detectStoreData.remarks || {};
            return detectStoreData.remarks[tabName];
        },
        saveAll: function(){
            // window.localStorage['detect'] = JSON.stringify(detectStoreData);
        },
        // 将整个tab的数据保存起来
        saveTab: function(tabName, data){
            detectStoreData[tabName] = data;
            // detectStore.saveAll();
            return true;
        },
        // @param: noInstantSave  不要立即保存
        saveItem: function(tabName, index, data, noInstantSave){
            var tabData = detectStoreData[tabName];
            if(!tabData){
                tabData = detectStoreData[tabName] = {};
            }
            tabData[index] = data;
            if(!noInstantSave){
                // detectStore.saveAll();
            }
            return true;
        },
        saveRemark: function(tabName, remark){
            detectStoreData.remarks = detectStoreData.remarks || {};
            detectStoreData.remarks[tabName] = remark;
            detectStore.saveAll();
        },
        // 将未作修改的值 全部设为"正常"(默认值)
        // 效果: 只有value, index是和items相匹配的
        // "{"car-head":[["划痕","涂装色差"],"正常","正常","正常","正常","正常","正常","正常","正常","正常","正常","正常","正常","正常"],...
        setRestNormal: function(){
            var allTabs = detectionData.getTabs();
            // traverse all tabs and datas
            allTabs.forEach(function(tab){
                var items = detectionData.getItems(tab.name);
                items.forEach(function(item, index){
                    var curVal = detectStore.getItem(tab.name, index);
                    if( !detectStore.itemEdited(curVal) ){
                        var defaultData = {
                            selected: [item.defaultVal],
                            other: ''
                        };
                        // 修改每一个item时不立即保存
                        detectStore.saveItem(tab.name, index, defaultData, true);
                    }
                });
            });
            // 最后做保存
            detectStore.saveAll();
        },
        clear: function(){
            detectStoreData = {};
        },
        itemEdited: function(itemVal){
            // item的val是一个对象, selected,和picture other
            if(isEmptyObj(itemVal) ){
                return false;
            }
            // 有selected 或者 有other
            if( (itemVal.selected && itemVal.selected.length >= 0) || itemVal.other){
                return true;
            }
            else{
                return false;
            }
        },
        exportData: function(){
            // console.time('export data');
            var DEDA = window.detectionData;
            var deStore = window.detectStore;

            var detectionResult = {};
            var detectTabs = DEDA.getTabs();
            detectTabs.forEach(function(tab){
                var tabItems = DEDA.getItems(tab.name);
                var groups = DEDA.getGroups( tab.name );
                // 某个tab是分组的
                // group相当于是一个tab
                if(groups){
                    groups.forEach(function(group){
                        var groupResult = detectionResult[group.name] = {};
                        // items is an array of item index number
                        group.items.forEach(function(itemIndex){
                            var realItem = tabItems[itemIndex];
                            var itemVal = deStore.getItem(tab.name, itemIndex);
                            if(deStore.itemEdited(itemVal)){
                                var pics = itemVal.pictures || [];
                                var detection;

//                                if(DEDA.isItemHasUnit(realItem.defaultVal)){
//                                    detection = consUnitItemVal(realItem, itemVal.selected);
//                                }
//                                else{
//                                    detection = itemVal.selected.join('&|&');
//                                }
								var statusVal = (itemVal.selected[0] == realItem.defaultVal)? 2:1;
								if(statusVal === 1){
									if(DEDA.isItemHasUnit(realItem.defaultVal)){
										detection = consUnitItemVal(realItem, itemVal.selected);
									} else {
										detection = consFaultItemVal(realItem, itemVal.selected);
									}
								} else {
									detection = itemVal.selected.join('&|&');
								}
								groupResult[realItem.dataKey] = {
                                    detection: detection,
                                    images: pics.join(','),
                                    status: statusVal,
                                    other: itemVal.other
                                }
                            }
                        });
                    });
                }
                else{
                    var tabResult = detectionResult[tab.name] = {};
                    tabItems.forEach(function(item, index){
                        var itemVal = deStore.getItem(tab.name, index);
                        if(deStore.itemEdited(itemVal)){
                            var pics = itemVal.pictures || [];
							var statusVal = (itemVal.selected[0] == item.defaultVal)? 2:1;
							if(statusVal === 1){
								detection = consFaultItemVal(item, itemVal.selected);
							} else {
								detection = itemVal.selected.join('&|&');
							}
							tabResult[item.dataKey] = {
                                detection: detection,
                                images: pics.join(','),
                                status: statusVal,
                                other: itemVal.other
                            };
                        }
                    });
                    var comment = DEDA.getRemark(tab.name);
                    if(comment){
                        tabResult[comment.dataKey] = {
                            detection: '',
                            pictures: '',
                            other: deStore.getRemark(tab.name),
                            status: 2
                        };
                        // console.log( detectionResult[tab.name] );
                    }
                }
            });
            // console.timeEnd('export data');
            console.log(detectionResult);
            return detectionResult;
        },
        importData: function(serverData, tabs){
            detectStore.clear();
            var DEDA = window.detectionData;
            tabs.forEach(function(tab){
                detectStoreData[tab.name] = [];
                var groups = DEDA.getGroups( tab.name );
                // 某个tab是分组的
                // group相当于是一个tab
                if(groups){
                    // 多组 取到每一组的数据
                    groups.forEach(function(group){
                        var groupData = serverData[group.name];
                        if(groupData){
                            // 数据遍历
                            var clonedData = $.extend(true, {}, groupData);;
                            var items = detectionData.getItems(tab.name);
                            for(var i in clonedData){
                                var itemInfo = getItemDetailByKey(items, i);
                                var itemServerVal = clonedData[i];
                                if(itemInfo.keyIndex !== false){
                                    var selected;
                                    if(itemServerVal.status === 1){
                                        selected = deconsUnitItemVal(itemServerVal, itemInfo.item);
										console.log(selected)
                                    }
                                    else{
										if(!detectionData.isNewVersion() && itemServerVal.detection){
											itemServerVal.detection = itemServerVal.detection.split('&|&').join('/');
										}
										selected = itemServerVal.detection.split('&|&')
									}
                                    var images = (itemServerVal.images)?itemServerVal.images.split(',') : [];
                                    detectStoreData[tab.name][itemInfo.keyIndex] = {
                                        selected: selected,
                                        pictures: images,
                                        other: itemServerVal.other
                                    };
                                }
                                else{
                                    detectStoreData[tab.name][itemInfo.keyIndex] = {};
                                    // console.warn('this datakey was not found in this tab:', i, tab.name);
                                }
                            }
                        }
                    });
                }
                else{
                    var tabData = serverData[tab.name];
                    
                    if(tabData){
                        var clonedData = $.extend(true, {}, tabData);
                        var items = detectionData.getItems(tab.name);
                        for(var i in clonedData){
                            var itemInfo = getItemDetailByKey(items, i);
                            var itemServerVal = clonedData[i];
                            if(itemInfo.keyIndex !== false){
                                var images = (itemServerVal.images)?itemServerVal.images.split(',') : [];
								var selected;
								if(itemServerVal.status === 1){
									selected = deconsUnitItemVal(itemServerVal, itemInfo.item);
								}
								else{
									selected = itemServerVal.detection.split('&|&')
								}
                                detectStoreData[tab.name][itemInfo.keyIndex] = {
                                    selected: selected,
                                    pictures: images,
                                    other: itemServerVal.other
                                };
                            }
                            else{
                                detectStoreData[tab.name][itemInfo.keyIndex] = {};
                                // console.warn('this datakey was not found in this tab:', i, tab.name);
                            }
                        }

                        var comment = DEDA.getRemark(tab.name);
                        if(comment){
                            var commentVal = clonedData[comment.dataKey];
                            if(commentVal){
                                detectStore.saveRemark(tab.name, commentVal.other);
                            }
                            // console.log( detectionResult[tab.name] );
                        }
                    }
                    else{
                        // console.log('no data from server');
                    }
                }
            });

            function getItemDetailByKey(items, dataKey){
                var hasThisKey, keyIndex;
                hasThisKey = items.some(function(item, index){
                    keyIndex = index;
                    return (item.dataKey == dataKey);
                });
                if(hasThisKey){
                    return {
                        keyIndex: keyIndex,
                        item: items[keyIndex]
                    };
                }
                else{
                    return {
                        keyIndex: false
                    };
                }
            }
        }
    }
})();