// 通过vin码推荐车型
// 用户选择车型
// 通过车型code获取车型配置数据
// 将配置数据转成ruby后端可接受的数据
AuctionTypein.factory('ModelConfigTransfer', function(){
    var OTHER = 'other';
    // 车体
    var bodyTransfer = {
        5: 'two',  // 两厢车
        6: 'three',  // 三厢车
        1: 'suv',  // SUV
        2: 'mpv',  // MPV
        3: 'roadster',  // 敞篷
        4: 'sports',  // 跑车
        7: 'estate',  // 旅行车
        8: 'pcut'  // 皮卡车
    };
    // 燃料/供油
    var fuelTransfer = {
        '1': 'gasoline',  // 汽油
        '2': 'diesel',  // 柴油
        '4': 'electric',  // 电动
        '3': 'mixture', //混合
		'6': 'other' //其他
    };
	//进气方式
	var inletTypeTransfer = {
		'1': 'naturally_aspirated',
		'7': 'supercharged',
		'5': 'double_boost',
		'3': 'double_vortex_boost',
		'9': 'vortex_supercharger',
		'11': 'other'
	};
	//驱动形式
	var drive_formTransfer = {
		'9':  'ff',
		'11': 'fr',
		'13': 'fwd',
		'5':  'mr',
		'7':  'mwd',
		'15': 'rr',
		'17': 'rwd'
	};
    // 排放标准
    var emissionTransfer = {
        '4': 'g1',
        '3': 'g2',
        '1': 'g3',
        '2': 'g4',
        '5': 'g5'
        // '欧Ⅰ' : 'o1',
        // '欧Ⅱ' : 'o2',
        // '欧Ⅲ': 'o3',
        // '欧Ⅳ': 'o4',
        // '欧Ⅴ': 'o5'
   };

    // 颜色
    var colorTransfor = {
        2: "#888787",   // 深灰色
        4: "#ffffff",   // 白色
        11: "#79386a",   // 紫色
        5: "#ca2128",   // 红色
        // : "#98cb68",   // 绿色
        6: "#396bb3",   // 蓝色
        1: "#efecec",   // 银色
        9: "#e7d3ae",   // 香槟色
        10: "#fbdc04",  // 黄色
        3: "#000000"  // 黑色
    };
   // 变速箱
    var gearTypeTransfer = {
        1: 'mt',  // MT-手动
        2: 'at',  // AT-自动
        6: 'amt',  // AMT-机械式变速
        4: 'cvt',  // CVT-无极
        5: 'dsg',  // DSG-双离合
        3: 'tiptronic'  // 手自一体
    };

    // 配置列表
    var configList = {
        // 防抱死制动系统
        fbsz: 'abs',
		//刹车辅助系统
		brakeAssist: 'eba',
		//车身稳定控制系统
		stabilityControl: 'esps',
		//后视镜电动调节
		backMirrorElectricAdjustment: 'power_mirrors',
		//车内中控锁
		centralDoorLock: 'central_locking',
		//遥控钥匙
		remoteKey: 'smart_key',
		//后驻车雷达
		backRada: 'reversing_radar',
		//备用轮胎
		spareWheel: 'spare_tire',
		//真皮/仿皮座椅
		leatherSeat: 'leather_seats',
		// 导航系统
        ddxt: 'gps',
        // 音响系统    
        dvdd: 'dvd',
        // 倒车影像系统  
        dcyx: 'back_eye_camera',
        // 电动调节前座椅     
        ddtj: 'power_seat',
        // 天窗  
        qjtc: 'skylights',
        // 前后电动升降窗     
        qhdd: 'electric_windows',
        // 电动折叠后视镜     
        ddzd: 'power_mirrors',
        // 安全气囊    
        aqql: 'srs',
        // 空调  
        zdhw: 'air_condition',
        // 定速巡航    
        dsxh: 'cruise',
        // 一键启动    yjqd
		yjqd: 'one_key'
        // 大灯清洗    ddtc 
        // 车载雷达   czld
        // 前座椅加热   zpzy
        // 氙气大灯    sqdd
    };

    return {
        // 排放标准
        getEnvironment: function(nameCode){
            return emissionTransfer[nameCode];
        },
        // 几厢车
        getBody: function(nameCode){
            var res = bodyTransfer[nameCode];
            return res;
        },
        // 变速箱类型
        getGearboxType: function(typeCode){
            return gearTypeTransfer[typeCode];
        },
        // 进气方式
        getInletType: function(typeCode){
            return inletTypeTransfer[typeCode];
        },
        // 驱动形式
        getDrive_form: function(typeCode){
            return drive_formTransfer[typeCode] || OTHER;
        },
        // 燃油类型  供油系统
        getFuelType: function(nameCode){
            return fuelTransfer[nameCode];
        },
        getColor: function(colorCode){
            return colorTransfor[colorCode];
        },
        getConfigList: function(data, scope){
            if(data.configList && Array.isArray(data.configList)){
                
                var count = [];

                data.configList.forEach(function(cc){
                    var code = cc.configurationCode;
                    var matchedServerKey = configList[code];
                    // 没有这个项目, 跳过
                    if(!matchedServerKey){
                        return;
                    }
                    var result = undefined;
                    var val = cc.configurationValue;
                    if( val == 2){
                        result = 1;
                    }
                    else if(val == 1 || val == 4){
                        result = 0;
                    }
                    else if(val == 3){
                        result = 10;
                    }
                    scope.carInfo.configuration[matchedServerKey] = result;

                    count.push({
                        name: matchedServerKey,
                        value: result
                    })
                });
            }
        }
    }
})