/**
 * @ngdoc Service
 * @name DataService
 * @description
 *   get and restore data from different views.
 */
AuctionTypein.factory('DataService', function ($http, LevelStoreService, NetService) {

    function isInCanServeCities(canServeCities, carInCity){
        carInCity = String(carInCity);
        return (canServeCities && canServeCities.some)? canServeCities.some(function(c){
            return c === carInCity;
        }) : false;
    }
    return {
		/**
		 * @constant
		 * @memberof DataService
		 * @type {Object}
		 * @default {auction:{}} set the default pai_data for auction view
		 */
        pai_data:{
            auction: {
                "open_price": "",                              // 起拍价
                "reserve_price": "",                           // 保留价
				"commission":"",
                "others": "" ,                         // 竞拍的其他说明
                "p_seller":"",
				"contact":"",
				"contact_mobile":"",
				"expected_response_time":"",
                personal_seller: {
                    "name": "",
					"expected_price":"",
                    "mobile": ""
                }
            }

        },
        pics_uploaded:[],//每次保存后，成功上传的图片的本地路径集合
        carType: 1, //车辆类型，0 新车未上牌 10 新车已上牌 1 二手车
		carTypeSaved: '', //车辆类型，0 新车未上牌 10 新车已上牌 1 二手	车
		carTypeChange: false, //判断本地是否修改了carType
        paiFeedBack:false,
        commission:0,
		version: 5,
        is_zhibao:false,
        paiType: 1, //拍卖类型 0 实时拍 1 现场拍 2 两者均有
		accountType: '', //获取发车帐号来源，神州 000139
		basic_data:{basic:{},procedure:{},configuration:{}},
		price_data:{},
        pic_data:[],
        detection_data:{},
		getObjectLength: function(obj){
			var num = 0;
			for(var i in obj){
				num++;
			}
			return num;
		},
		//获取shop_id
		getAccountType: function(){
			return this.accountType;
		},
    //判断是否可以质保
    asyncQAVerify:function(json,callback){
      console.log(json);
      var base_url = "http://insurance.souche.com";
      var rankLevel;
      if(window.h5_is_dev){
          var base_url = "http://qacheniu.sqaproxy.souche.com"
      }
      if(json.detection_data&&json.detection_data.data && json.detection_data.data.conclusion){
        var conclusion = json.detection_data.data.conclusion
          rankLevel = conclusion.zhibao_rank;
      }
      if(!rankLevel){
        return callback(null,false);
      }
      $.ajax({
        url:base_url+"/api/qacalapi/validQa.json",
        data:{
            brandCode:json.basic_data.data.basic.brand_code,
            seriesCode:json.basic_data.data.basic.series_code,
            seatCount:json.basic_data.data.basic.seatCount?json.basic_data.data.basic.seatCount.replace("a",""):"",
            carNature:json.basic_data.data.basic.car_nature,
            useNature:json.basic_data.data.basic.use_nature,
            carriage:json.basic_data.data.configuration.carriage,
            fuelType:json.basic_data.data.configuration.supply_system,
            firstLicensePlateDate:moment(json.basic_data.data.basic.begin_at*1000).format("YYYY-MM")
        },
        dataType:"json",
        success:function(data){
            if(data.success){
                callback(null,true)
            }else{
              callback(null,false)
            }
        }
      });
    },
        //判断是否符合秒贷
        asyncLoanVerify:function(json,callback){
            var base_url = "https://consumerloan.souche-inc.com";
            var rankLevel;
            if(window.h5_is_dev){
                var base_url = "https://consumerloan.sqaproxy.souche.com/"
            }
            $.ajax({
                url:base_url+"/api/callback/v1/cardetectionreportapi/isSupportLoan.json",
                data:{
                    car:JSON.stringify(json)
                },
                dataType:"json",
                type:"POST",
                success:function(data){
                    if(data.data){
                        callback(null,true)
                    }else{
                        callback(null,false)
                    }
                }
            });
        },
        //获取搜车认证
		getSoucheVerify: function(canServeCities){
			var self = this;
			var rankLevel = '';
			var verifyBasic =false;
			var reLevel = /优/;
			var soucheVer = false;

			if(self.detection_data && self.detection_data.conclusion){
				var conclusion = self.detection_data.conclusion;
					rankLevel = conclusion.zhibao_rank||conclusion.detection_rank;
			}

			if(self.basic_data){
        var carNature = self.basic_data.basic.car_nature, useNature = self.basic_data.basic.use_nature;
        var carInCity = self.basic_data.basic.city_id;
        if(carNature==='personal' && useNature==='non_operational'){
          verifyBasic = true;
        }
        if(self.basic_data.configuration&&'mbao|tzhong|other'.indexOf(self.basic_data.configuration.carriage)!=-1 ){
          verifyBasic = false;
        }
			}

			var verifyLevel = reLevel.test(rankLevel);
			if( verifyLevel && verifyBasic){
				soucheVer = true;
			}
			return soucheVer;
		},

        //获取检测信息数据
        getDetectData:function(){

            var DEDA = window.detectionData;
			var _self = this;
			DEDA.setData(_self.version);
			var detectionData = this.detection_data

			var totalCount = 0, filled = 0;
            var detectTabs = DEDA.getTabs();
			detectTabs.forEach(function(tab){
                var groups = DEDA.getGroups(tab.name);

				var tabItems = DEDA.getItems(tab.name);

                if(groups){
                    var tabResult = {};
                    groups.forEach(function(group){
                        var groupData = detectionData[group.name];
                        if(groupData){
                            tabResult = $.extend(true, tabResult, groupData);
                        }
                    });
                    tabItems.forEach(function(item, index){
                        totalCount++;
						if(!(_self.version>=5) && tabResult[item.dataKey]){
							tabResult[item.dataKey].detection = tabResult[item.dataKey].detection.replace(/&\|&/g,'/')
						}
                        var itemVal = tabResult[item.dataKey] ;
                        if(itemVal && (itemVal.detection || itemVal.other)){
                            filled++;
                        }
                    });
                }
                else{
                    var tabResult = detectionData[tab.name];

                    if(!tabResult){
                    }
                    tabItems.forEach(function(item, index){
                        // 计总数
                        totalCount++;
                        if(!tabResult){
                            return;
                        }
                        var itemVal = tabResult[item.dataKey];
                        if(itemVal && (itemVal.detection || itemVal.other)){
                            filled++;
                        }
                        else{
							console.log(filled)
						}
                    });
                }
            });
            var conclusionData = this.detection_data.conclusion || {};
            var description = (_self.paiType !=0) ?  "可选填" : "未完成";
			if(filled === totalCount){
				if(conclusionData.detection_rank && conclusionData.detection_cost){
					description = '已完成';
				}
				else{
					description = '未评级';
				}
			}

			return {
                data:$.extend(true,{},this.detection_data),
                total_count: totalCount, //总数
                type_count: filled, //填写项数
                description: description
            };
        },
        setDetectData:function(detectData){
            this.detection_data = $.extend(true, this.detection_data, detectData);
        },
        setLevelData:function(levelData){
            this.detection_data.conclusion = $.extend(true, {}, levelData);
        },
        //获取基本信息数据,basic,procedure,configuration 三部分
        getBasicData:function() {
			var that = this;
			var type_count = 0;
			var total_count = 61;
			var carInfoData = this.basic_data;
			var basicTabs = window.basicInfoData.tabsInfo;
			var ignoreCount = 0;
			var isOldVersion = (carInfoData.basic && carInfoData.basic.version && carInfoData.basic.version >=5) ? false : true;
			if(basicTabs.length===3 && this.carType === 0){
				basicTabs.splice(2,1);
			}
			if(basicTabs.length===2 && this.carType === 1){
				basicTabs.splice(2,0,{text: '手续信息', name: 'procedureInfo'});
			}
			if( this.carType === 0){
				var usedLabels = window.basicInfoData.usedCarLabels;
				for(var i in usedLabels){
					var val = usedLabels[i];
					carInfoData.basic[val]='';
				}
				for(var k in carInfoData.procedure){
					if(k!=="others") carInfoData.procedure[k]='';
				}
				total_count = total_count - 25;
			}
			if(carInfoData.basic) {
				delete carInfoData.basic.pictures;
				delete carInfoData.basic.has_detection;
				delete carInfoData.basic.car_type;
				delete carInfoData.basic.version;
			}
			if(carInfoData.procedure && carInfoData.procedure.transfer_number*1 >0) {total_count++ ;}
			if(carInfoData.procedure && carInfoData.procedure.travel_tax_due_date) delete carInfoData.procedure.travel_tax_due_date;
			if(isOldVersion){
				if(carInfoData.basic && carInfoData.basic.others){
					delete carInfoData.basic.others;
				}
				if(carInfoData.configuration && carInfoData.configuration.others){
					delete carInfoData.configuration.others;
				}

				if(carInfoData.basic && carInfoData.basic.vin_desc){
					delete carInfoData.basic.vin_desc;
				}
				if(carInfoData.configuration && carInfoData.configuration.ebd_ebv){
					delete carInfoData.configuration.ebd_ebv;
				}
			}

			for(var i in carInfoData){
				for (var detail in carInfoData[i]){
					if(carInfoData[i][detail]!=null && carInfoData[i][detail]!==''){
						type_count ++;
					}
				}
            }
			if(carInfoData.basic){
				if(carInfoData.basic.brand) ignoreCount += 2;
				if(carInfoData.basic.series) ignoreCount += 3;
				if(carInfoData.basic.from_detector!=undefined) ignoreCount++;
				if(carInfoData.basic.authshop_id) ignoreCount++;
				if(carInfoData.basic.holder_mobile) ignoreCount++;
				if(carInfoData.basic.holder_id) ignoreCount++;
				if(carInfoData.basic.holder_name) ignoreCount++;
				if(carInfoData.basic.id) ignoreCount++;
				if(carInfoData.basic.model) ignoreCount++;
				if(carInfoData.basic.vehicle_attribution_province) ignoreCount++;
				if(carInfoData.basic.vehicle_attribution_city) ignoreCount++;
                if(carInfoData.basic.attribution_city_code) ignoreCount++;
                if(carInfoData.basic.attribution_province_code) ignoreCount++;
				if(carInfoData.basic.province) ignoreCount++;
				if(carInfoData.basic.city) ignoreCount++;
                if(carInfoData.basic.province_code) ignoreCount++;
                if(carInfoData.basic.city_code) ignoreCount++;
			}
			if(carInfoData.procedure) {
				if (carInfoData.procedure.illegal_processing && ((carInfoData.procedure.illegal_processing.present * 1) === 1)) {
					var leng = that.getObjectLength(carInfoData.procedure.illegal_processing);
					if (leng != 4) ignoreCount++;
				}
				if (carInfoData.procedure.where_to) {
					var whereTo = carInfoData.procedure.where_to;
					// if(isOldVersion){
					// 	delete carInfoData.procedure.where_to_desc.migration_discount_price;
					// }
					var whereLength = that.getObjectLength(carInfoData.procedure.where_to_desc);

					if(whereTo === 'local'){
						if (whereLength != 1) ignoreCount++;
					} else if(whereTo === 'non_local'){
						if (whereLength != 2) ignoreCount++;
					} else {
						if (whereLength != 3) ignoreCount++;
					}
				}
				if(carInfoData.procedure.cost_price) ignoreCount++;
                if(carInfoData.procedure.transfer_number == 0) {
                    ignoreCount++;
                    total_count = total_count - 2;;
                };
                if(carInfoData.basic.is_modification == 1) {
                    total_count++;

                };
			}


			type_count = type_count - ignoreCount;
			console.log('type_count:'+type_count)
			console.log('total_count:'+total_count)
            var result = $.extend(true,{},carInfoData)
            //moment(result.basic.begin_at*1000).format("YYYY-MM-DD")
            return {
                data: result,
                total_count: total_count, //总数
                type_count:type_count //填写项数
            };
        },
		setBasicData:function(carInfoData){
			this.basic_data = $.extend(true,{},carInfoData);
		},
        setCommentData: function(comment){
            this.basic_data = $.extend(true, this.basic_data, { procedure: { others: comment } });
        },
        getCommentData: function(){
          try{
            return this.basic_data.procedure?this.basic_data.procedure.others:"";
          }catch(e){
            return "";
          }
            
        },
        //获取拍卖信息数据
        getPaiData:function(){
            var result = {};
            var total_count = 3;
            var type_count = 0;
			if(this.carType === 0){
				total_count = 2;
				delete this.pai_data.auction.commission;
				delete this.pai_data.auction.p_seller;
				delete this.pai_data.auction.personal_seller;
			} else {
				total_count = 3;
			}
            if(this.pai_data.auction){
                this.pai_data.is_daipai = 0;
                if(this.pai_data.personal_seller){
                    for(var i in this.pai_data.personal_seller){
                        if(this.pai_data.personal_seller[i]){
                            this.pai_data.is_daipai = 1;
                        }
                    }
                }
                for(var i in this.pai_data.auction){
                    if(i=="open_price"|| i=="reserve_price" || i=="p_seller") {
						if (this.pai_data.auction[i] !== "" && this.pai_data.auction[i] !== null) {
							if(i=="p_seller"){
								if(this.pai_data.auction.p_seller!=2){
									type_count++;
									delete this.pai_data.auction.personal_seller;
								} else if(this.pai_data.auction.personal_seller && this.pai_data.auction.personal_seller.name && this.pai_data.auction.personal_seller.mobile){
									type_count++;
								}
							} else {
									type_count++;
								}
							}

					}
                }
//                result.auction_type = this.paiType;
            }
            return {
                data: $.extend(true,{},this.pai_data), //最终的数据，与api相对
                total_count:total_count, //总数
                type_count:type_count //填写项数
            }
        },
        setPaiData:function(_data){
            this.pai_data = $.extend(true,{},_data);
        },
		setPriceData: function(price_o){
			this.price_data =  $.extend(true,{},price_o);
		},
		getPriceData: function(){
			return this.price_data;
		},
        getPicData:function(){
            var arr = [];
            this.pic_data.forEach(function(i){
                arr.push(i)
            })
            return {
                data:arr,
                type_count:this.pic_data.length,
				total_count: (this.carType!==1 ? 11 : 11)
            };
        },
        setPicData:function(pics){
            var arr = [];
            pics.forEach(function(i){
                if(i&&arr.indexOf(i)==-1)
                    arr.push(i)
            })
            this.pic_data = arr
        },
		isEmptyObj: function(obj){
			for(var i in obj){
				return false;
			}
            return true;
		}
    }
});
