(function() {
    var carInfoData = basicInfoData.getCarInfo();

    //初始化的时候把秒数转化成date
    var getDateFromSecondTimestamp = function (object, key) {
        if (object[key] && object[key] > 1000000) {
            object[key] = new Date(object[key] * 1000);
        }
    }
    //保存的时候把date转化成秒数
    var getSecondTimestampFromDate = function (object, key) {
        if (object[key] && object[key].getTime) {
            object[key] = object[key].getTime() / 1000
        }
    }

    //保留两位小数
    var numFixed = function($object, object, key) {
        if (!object[key]) return;
        if (typeof object[key] == 'number') {
            $object[key] = object[key] = parseFloat(object[key].toFixed(2));
        } else if (typeof object[key] == 'string') {
            $object[key] = object[key] = parseFloat(parseFloat(object[key]).toFixed(2));
        }
    }

    var uppercaseConversion = function(object, key) {
        if (object&&object[key]) {
            object[key] = object[key].toString().toUpperCase();
        }
    }

    var standardEmission = function($object, object, key) {
        if (!object[key]) return;
        if (typeof object[key] == 'number') {
            $object[key] = object[key] = parseFloat(object[key].toFixed(1));
        } else if (typeof object[key] == 'string') {
            $object[key] = object[key] = parseFloat(object[key]).toFixed(1);
        }
    }

    var vinMatchCache = {};
    var stopMatchOnce;

    function setConfigToScope(configData, scope, transfer){
        // 从配置数据中拿不到 就置为空
        // -----------------  基本信息   -------------------------------
        // 新车(指导)价
        if(configData.carNewPrice){
            scope.carInfo.basic.original_price = Number((configData.carNewPrice/10000).toFixed(2));
            $('[ng-model="carInfo.basic.original_price"]').attr('disabled', true);
        }
        else{
            scope.carInfo.basic.original_price = '';
            $('[ng-model="carInfo.basic.original_price"]').attr('disabled', false);
        }
        // 排放标准
        var emissionStandardNum = configData.emissionStandard;
            //服务端返回的数值有时会是分数，如果是分数，就不输出
        if(typeof emissionStandardNum === 'string' && emissionStandardNum % 1 === 0){
            scope.carInfo.basic.environment = transfer.getEnvironment(emissionStandardNum);
        }
        else{
            scope.carInfo.basic.environment = '';
        }
        // 排量
        if(configData.engineVolume){
            scope.carInfo.basic.engine_capacity = configData.engineVolume*1>0 ? (configData.engineVolume/10 + ((configData.intakeType*1===1) ? "L" : "T")) : '';;
        }


        // 颜色
        if(configData.color){
            scope.carInfo.basic.color = transfer.getColor(configData.color);
        }
        else{
            scope.carInfo.basic.color = '';
        }


        // -----------------  配置信息   -------------------------------
        // 变速形式
        scope.carInfo.configuration.variable_form = transfer.getGearboxType(configData.gearboxType);
        // 驱动方式
        scope.carInfo.configuration.drive_form = transfer.driveType(configData.driveType);
        // 进气方式
        scope.carInfo.configuration.inlet = transfer.getInletType(configData.intakeType);
        // 车厢
        scope.carInfo.configuration.carriage = transfer.getBody(configData.body);
        // 供油系统
        scope.carInfo.configuration.supply_system = transfer.getFuelType(configData.fuelType);
        //
        // 配置列表中的数据
        transfer.getConfigList(configData, scope);
        // -----------------  手续信息   -------------------------------
    }

    AuctionTypein.controller('BaseCtrl', function (
        $scope,
        $ionicScrollDelegate,
        $stateParams,
        $ionicPopup,
        $ionicModal,
        $ionicLoading,
        $http,
        $timeout,

        DataService,
        NetService,
        ModelConfigTransfer,

        Validator
        ) {
        console.time("basectrl begin")
        Jockey.send("SetRightBar",{
            title:"保存",
            show: 1
        })
        Jockey.send("SetWebViewTitle",{
            title: '基本信息'
        });
        window.rightButtonEvent = function(){
            $scope.saveBasicInfo();
        }
        $scope.tabs = basicInfoData.tabsInfo;
        $scope.cardItems = basicInfoData.cardItems;
        $scope.currentTab = 'basicInfo';
        $scope.carInfo = DataService.getBasicData().data || {basic: {}, configuration: {}, procedure: {}};
        console.log('#############', $scope.carInfo);
        $scope.cardId = {};
        $scope.provincedb = []
        $scope.vehicleCidydb = [];
        $scope.cidydb = [];
        $scope.isBrand = false;
        $scope.isUsedCar = (parseInt(DataService.carType) !== 0); //!
        $scope.paiType = DataService.paiType;
        //$scope.isCardId = false;
//        $scope.toggleCardId = function (type) {
//            if (type) {
//                $scope.isCardId = false;
//            } else {
//                $scope.isCardId = !$scope.isCardId;
//            }
//        };

        // $scope.carInfo = DataService.getBasicData().data;
        console.log($scope.carInfo);
        if ($scope.carInfo.basic) {
            getDateFromSecondTimestamp($scope.carInfo.basic, 'begin_at')
            getDateFromSecondTimestamp($scope.carInfo.basic, 'manufacture_date')
            // NetService.convertUnitToWan($scope.carInfo.basic, 'mileage');
            // NetService.convertUnitToWan($scope.carInfo.basic, 'original_price');

        }
        if ($scope.carInfo.procedure) {
            getDateFromSecondTimestamp($scope.carInfo.procedure, 'year_insurance')
            getDateFromSecondTimestamp($scope.carInfo.procedure, 'compulsory_insurance')
            // getDateFromSecondTimestamp($scope.carInfo.procedure, 'travel_tax_due_date')
            // getDateFromSecondTimestamp($scope.carInfo.procedure, 'business_insurance')
            // getDateFromSecondTimestamp($scope.carInfo.procedure, 'transferred_at')

        }

        // 如果是"编辑车辆" 且vin码已填写, 就阻止在进入这个route的时候立即匹配
        $scope.$on('$stateChangeSuccess', function(event, toState, toParams, fromState, fromParams){
            if($scope.carInfo.basic && $scope.carInfo.basic.vin_code && $scope.carInfo.basic.vin_code.length == 17){
                stopMatchOnce = true;
            }
            else{
                stopMatchOnce = false;
            }
        });

        $timeout(function () {
            // if ($scope.carInfo && $scope.carInfo.basic && $scope.carInfo.basic.vehicle_attribution_province_id)
            //     $scope.carInfo.basic.vehicle_attribution_province_id = $scope.carInfo.basic.vehicle_attribution_province_id * 1
            // if ($scope.carInfo && $scope.carInfo.basic && $scope.carInfo.basic.vehicle_attribution_city_id)
            //     $scope.carInfo.basic.vehicle_attribution_city_id = $scope.carInfo.basic.vehicle_attribution_city_id * 1
            //
            // if ($scope.carInfo && $scope.carInfo.basic && $scope.carInfo.basic.province_id)
            //     $scope.carInfo.basic.province_id = $scope.carInfo.basic.province_id * 1
            // if ($scope.carInfo && $scope.carInfo.basic && $scope.carInfo.basic.city_id)
            //     $scope.carInfo.basic.city_id = $scope.carInfo.basic.city_id * 1
        }, 0, false);
        NetService.getProvince(function(data){
            $scope.provinceVecdb = data;
            $scope.provincedb = data;
            if ($scope.carInfo.basic && $scope.carInfo.basic.province_id) {
                NetService.getCityG($scope.carInfo.basic.province_id, function (data) {
                    $scope.cidydb = data;
                })
            }

            if ($scope.carInfo.basic && $scope.carInfo.basic.vehicle_attribution_province_id) {
                NetService.getCity($scope.carInfo.basic.vehicle_attribution_province_id, function (data) {
                    $scope.vehicleCidydb =  data;
                })
            }
            // $scope.getCity();
            // $scope.getCityG();
        })
        $timeout(function () {
            var url = 'http://42.120.61.109/model';
            $http.jsonp(url + '?callback=getCarBrand');
        }, 200)

        $scope.getCity = function () {
            if ($scope.carInfo.basic && $scope.carInfo.basic.vehicle_attribution_province_id)
                NetService.getCity($scope.carInfo.basic.vehicle_attribution_province_id, function (data) {
                    $scope.vehicleCidydb =  data;
                })
        }
        $scope.getCityG = function () {
            if ($scope.carInfo.basic && $scope.carInfo.basic.province_id)
                NetService.getCityG($scope.carInfo.basic.province_id, function (data) {
                    $scope.cidydb = data;
                })
        }
        $scope.getSeries = function (type) {
            if ($scope.tmpCarModelData.brand_code) {
                var url = 'http://42.120.61.109/model/b/';
                $http.jsonp(url + $scope.tmpCarModelData.brand_code + '?callback=getSeriesByBrand');
            }
            if(type){
                $scope.isSeries = true;
                $scope.isModel = false;
            }
        }
        $scope.getModels = function (type) {
            if ($scope.tmpCarModelData.series_code) {
                var url  =  'http://42.120.61.109/model/s/';
                $http.jsonp(url + $scope.tmpCarModelData.series_code + '?callback=getModelsBySeries');
            }
            if(type){
                $scope.isModel = true;
            }
        }


        //}
        $scope.changeDate = function (key, value) {
            $scope.carInfo.basic[key] = value / 1000;  //second as unit ,sync with ruby
        }
        $scope.changeDateProcedure = function (key, value) {
            $scope.carInfo.procedure[key] = value / 1000;  //second as unit ,sync with ruby
        }
        $scope.switchTab = function (index, e) {
            $scope.currentTab = $scope.tabs[index].name;
            $ionicScrollDelegate.scrollTop();
        }
        $scope.chooseBrand = function(){
            $scope.isBrand = true;
        }
        $scope.chooseBrandHide = function(){
            $scope.isBrand = false;
        }
        $scope.closeBrandModal = function(){
            $timeout(function(){
            $scope.isBrand = false;
            $scope.isSeries = false;
            $scope.isModel = false;}, 400)
        }

        // 选定品牌/车系 不去设置最终的数据, 选定车型才设定
        // 先存在临时变量里
        $scope.tmpCarModelData = {};
        $scope.setBrand = function(brand){
            $scope.tmpCarModelData.brand = brand.name;
            $scope.tmpCarModelData.brand_code = brand.code;
        }
        $scope.setSeries = function(series,key){
            $scope.tmpCarModelData.series = series.name;
            $scope.tmpCarModelData.series_code = series.code;
            $scope.tmpCarModelData.series_label = key;
        }
        $scope.setModel = function(model){
            // 选定车型 才把数据写入到scope的basic信息中
            for(var key in $scope.tmpCarModelData){
                $scope.carInfo.basic[key] = $scope.tmpCarModelData[key];
            }
            $scope.carInfo.basic.model = model.name;
            $scope.carInfo.basic.model_code = model.code;

            $scope.getModelConfigData(model.code);
        }
        $scope.analyzeData = function(data, conditional) {
            var obj = {};
            for (var i = 0; i < data.length; i++) {
                if (!obj[data[i][conditional]]) {
                    obj[data[i][conditional]] = [];
                }
                obj[data[i][conditional]].push(data[i]);
            }
            return obj;
        }

        window.getCarBrand = function (data) {
            if (data.msg == 'successful') {
                $scope.brandDb = $scope.analyzeData(data.data, 'initialsLetter');
            }
            $scope.getSeries();
            $scope.getModels();
        }
        window.getSeriesByBrand = function (data) {
            if (data.msg == 'successful') {
                $scope.seriesDb = $scope.analyzeData(data.data, 'subBrandName');
            }
        }
        window.getModelsBySeries = function (data) {
            if (data.msg == 'successful') {
                $scope.modelsDb = data.data;
            }
        }

        //本地发生编辑行为
        $scope.hasChangeBasicInfo = false;
        ////延时绑定值变化函数
        //setTimeout(function () {
        //    $scope.$watch("carInfo", function () {
        //        $scope.hasChangeBasicInfo = true;
        //    }, true)
        //}, 1000)

        // save basciInfo

        $scope.saveBasicInfo = function () {
            $timeout(function () {
                var result = $.extend(true,{},$scope.carInfo);
                console.log(result);
                if (result.basic) {
                    // 校验基本信息
                    // 中的 出厂日期,初登日期
                    var vBasicResult = Validator.pubCarBase(result.basic);
                    if(vBasicResult != true){
                        var errMsg = vBasicResult.map(function(item, index){
                            return (index+1) + '. ' + item;
                        }).join('<br>');
                        $ionicPopup.show({
                            title: '录入信息有如下错误:',
                            subTitle: errMsg,
                            scope: $scope,
                            buttons: [
                                {
                                    text: '确定',
                                    onTap: function (e) {
                                        return false;
                                    }
                                },
                            ]
                        });
                        return;
                    }
                }
                realSave(result);
            }, 0, false);

            function realSave(result){
                console.log(result);
                if(result.basic){

                    uppercaseConversion(result.basic, 'vin_code');
                    standardEmission($scope.carInfo.basic, result.basic, 'engine_capacity');
                    getSecondTimestampFromDate(result.basic, 'begin_at')
                    getSecondTimestampFromDate(result.basic, 'manufacture_date')
                    // NetService.convertUnitToYuan(result.basic, 'mileage');
                    // NetService.convertUnitToYuan(result.basic, 'original_price');
                }
                // 手续信息 还有 年检到期 和 强险到期
                if (result.procedure) {
                    getSecondTimestampFromDate(result.procedure, 'year_insurance')
                    getSecondTimestampFromDate(result.procedure, 'compulsory_insurance')
                }
                console.log(result);
                DataService.setBasicData(result);
                $scope.hasChangeBasicInfo = false;
                clearInterval(timer);
                window.history.go(-1)
            }


        }
        var timer = setInterval(function(){
            var carInfo = $.extend(true,{},$scope.carInfo)
            if (carInfo.basic) {
//                  if($scope.cardId.license_number){
//                      $scope.carInfo.basic.license_number = $scope.cardId.cardHead + $scope.cardId.license_number;
//                  }
                uppercaseConversion(carInfo.basic, 'vin_code');
                standardEmission($scope.carInfo.basic, carInfo.basic, 'engine_capacity');
                getSecondTimestampFromDate(carInfo.basic, 'begin_at')
                getSecondTimestampFromDate(carInfo.basic, 'manufacture_date')
                NetService.convertUnitToYuan(carInfo.basic, 'mileage');
                NetService.convertUnitToYuan(carInfo.basic, 'original_price');
            }
            if (carInfo.procedure) {
                getSecondTimestampFromDate(carInfo.procedure, 'year_insurance')
                getSecondTimestampFromDate(carInfo.procedure, 'compulsory_insurance')
                // getSecondTimestampFromDate(carInfo.procedure, 'travel_tax_due_date')
                // getSecondTimestampFromDate(carInfo.procedure, 'business_insurance')
                // getSecondTimestampFromDate(carInfo.procedure, 'transferred_at')
            }
            DataService.setBasicData(carInfo);
            $scope.hasChangeBasicInfo = false;
            console.log("save basic info")
        },30000)
        var isConfirming = false;
        $scope.showConfirm = function () {
            if ($scope.hasChangeBasicInfo) {
                if(isConfirming){
                    return;
                }
                isConfirming = true;
                $ionicPopup.show({
                    title: '当前录入信息尚未保存，是否保存?',
                    scope: $scope,
                    buttons: [
                        {
                            text: '不保存',
                            onTap: function (e) {
                                isConfirming = false;
                                window.history.go(-1)
                            }
                        },
                        {
                            text: '<b>保存</b>',
                            type: 'button-assertive theme-bg theme-border theme-color',
                            onTap: function (e) {
                                isConfirming = false;
                                $scope.saveBasicInfo();
//                              window.history.go(-1)
                            }
                        }
                    ]
                });
            } else {
                window.history.go(-1)
            }
        };

        // --------------------------- 通过vin码匹配车型 并推荐选择 ------------------------
        $scope.showModalRecommand = function(vinModelInfo){
            $scope.vinMatchedModels = vinModelInfo.map(function(m){
                return {
                    name: m.soucheModel
                    // brand: m.soucheBrandCode, // series: m.soucheSeriesCode,  // model: m.soucheModelCode
                }
            });
            $scope.recModal = $ionicModal.fromTemplate($('#model-rec-by-vin').html(),{
                scope: $scope,
                animation: 'slide-in-up'
            });
            $scope.recModal.show();
        };
        $scope.chooseMatchedModel = function($index){
            $scope.recModal.hide().then(function(){
                $scope.recModal.remove();
            });
            var vin = $scope.carInfo.basic.vin_code;
            var selectedModel = vinMatchCache[vin][$index];
            // 填充车型车系数据
            $scope.carInfo.basic = {
                vin_code: vin,
                brand: selectedModel.soucheBrand,
                brand_code: selectedModel.soucheBrandCode,
                series: selectedModel.soucheSeries,
                series_code: selectedModel.soucheSeriesCode,
                series_label: selectedModel.manufacturer,
                model: selectedModel.soucheModel,
                model_code: selectedModel.soucheModelCode,
            };
            $scope.getModelConfigData(selectedModel.soucheModelCode);
        };
        // 通过选定的车型code 从车型库获取配置数据
        $scope.getModelConfigData = function(modelCode){
            $ionicLoading.show({ template: '正在通过车型获取配置' });
            NetService.getConfigByModel(modelCode, function(err, data){
                if(!err){
                    setConfigToScope(data, $scope, ModelConfigTransfer);
                    $ionicLoading.hide();
                    return;
                }
                else{
                    $ionicLoading.show({ template: '获取配置失败, 请手工填写' });
                }
                $timeout(function(){
                    $ionicLoading.hide();
                }, 1000);
            });
        }

        $scope.fillManually = function(){
            $scope.recModal.hide();
        };

        $scope.$watch("carInfo.basic.vin_code",function(){
            if($scope.carInfo.basic.vin_code&&$scope.carInfo.basic.vin_code.length==17){
                if(stopMatchOnce){
                    stopMatchOnce = false;
                    return;
                }
                if( vinMatchCache[$scope.carInfo.basic.vin_code] ){
                    $scope.showModalRecommand(vinMatchCache[$scope.carInfo.basic.vin_code]);
                    return;
                }
                $ionicLoading.show({
                  template: '正在通过Vin码匹配车型数据'
                });
                NetService.getInfoByVIN($scope.carInfo.basic.vin_code,function(error,models){
                    if(!error){
                        if(isUsableVinData(models)){
                            vinMatchCache[$scope.carInfo.basic.vin_code] = models;
                            $scope.showModalRecommand(models);
                            $ionicLoading.hide();
                            return;
                        }
                        else{
                            $ionicLoading.show({
                              template: '匹配失败... 请你手动选择车型'
                            });
                        }
                    }
                    else{
                        $ionicLoading.show({
                          template: '获取失败... 请你手动选择车型'
                        });
                    }
                    $timeout(function(){
                        $ionicLoading.hide();
                    }, 1000);
                })
            }
        })
        // --------------------------- endof 通过vin码匹配车型 并推荐选择 ------------------------

        $scope.$watch("carInfo.basic.mileage",function(e){
            if ($scope.carInfo.basic.mileage) {
                if ($scope.carInfo.basic.mileage > 99.99) {
                    $scope.carInfo.basic.mileage = parseFloat($scope.carInfo.basic.mileage.toString().slice(0, -1));
                }
                if ($scope.carInfo.basic.mileage.toString().indexOf('.') >= 0 && $scope.carInfo.basic.mileage.toString().split('.').pop().length > 2) {
                    $scope.carInfo.basic.mileage = parseFloat($scope.carInfo.basic.mileage.toString().slice(0, -1));
                }
            }
        });
        $scope.$watch("carInfo.basic.price",function(e){
            if ($scope.carInfo.basic.price && $scope.carInfo.basic.price.toString().indexOf('.') >= 0 && $scope.carInfo.basic.price.toString().split('.').pop().length > 2) {
                $scope.carInfo.basic.price = parseFloat($scope.carInfo.basic.price.toString().slice(0, -1));
            }
        });

        $scope.$watch("carInfo.basic.pifa_price",function(e){
            if ($scope.carInfo.basic.pifa_price && $scope.carInfo.basic.pifa_price.toString().indexOf('.') >= 0 && $scope.carInfo.basic.pifa_price.toString().split('.').pop().length > 2) {
                $scope.carInfo.basic.pifa_price = parseFloat($scope.carInfo.basic.pifa_price.toString().slice(0, -1));
            }
        });

    });

function isUsableVinData(vinModelInfo){
    return vinModelInfo.every(function(m){
        return (m.soucheModel && m.soucheBrandCode && m.soucheSeriesCode && m.soucheModelCode);
    });
}


})();
