// 一个有缓存&防重复请求的数据服务
AuctionTypein.factory('LevelDefineService', function($http){
    var levelDefineData = undefined;
    var reqing = false;
    var callbackArr = [];
    return {
        getLevelData: function(callback){
            if(reqing){
                callbackArr.push(callback);
                return;
            }
            if(levelDefineData){
                setTimeout(function(){
                    callback(levelDefineData);
                });
            }
            else{
                reqing = true;
                callbackArr.push(callback);
				var rankUrl = (window.CheNiu&&CheNiu.isProduction()) ? 'http://paimai.souche.com/api/v2/cars/ranks/all' : 'http://paimaidev2.souche.com/api/v2/cars/ranks/all' ;
				$http.get(rankUrl).success(function(res){
                    reqing = false;
                    levelDefineData = res.data;
                    while(callbackArr.length>0){
                        callbackArr.shift()(res.data);
                    }
                });
            }
        }
    }
});

AuctionTypein.factory('LevelStoreService', function(LevelDefineService){
    var levelData = {};
    // obj: { groupName: selectedRank }

    var levelDefineData = undefined;
    LevelDefineService.getLevelData(function(data){
        levelDefineData = data;
    });
    return {
        getLevelDefine: function(callback){
            LevelDefineService.getLevelData(callback);
        },
        getLevel: function(groupName){
            return levelData[groupName];
        },
        getDefaultLevel: function(groupName){
            return levelDefineData[groupName][0].rank;
        },
        getRemark: function(){
            return levelData['remark'] || '';
        },
        setLevel: function(groupName, levelName, noInstantSave){
            if(levelName !== undefined){
                levelData[groupName] = levelName;
            }
            // else{
            //     if(!levelDefineData || !levelDefineData[groupName]){
            //         LevelDefineService.getLevelData(function(data){
            //             levelData[groupName] = levelDefineData[groupName][0].rank;
            //         });
            //     }
            //     else{
            //         // levelData[groupName] = levelDefineData[groupName][0].rank;
            //     }
            // }
            
            if(!noInstantSave){
                this.save();
            }
        },
        saveRemark: function(remark){
            levelData.remark = remark;
            this.save();
        },
        save: function(){
            // window.localStorage['detection-level'] = JSON.stringify(levelData);
        },
        setRestDefault: function(){
            levelData.remark = '';
            ['ranks', 'costs'].forEach(function(group){
                if(!levelData[group]){
                    this.setLevel(group);
                }
            }.bind(this));
            this.save();
        },
        exportData: function(){
            var leStore = this;
            var rank = leStore.getLevel('ranks');
            var cost = leStore.getLevel('costs');

            return {
                "detection_rank": rank,
                "detection_cost": cost,
                "detection_conclusion_comment": leStore.getRemark()
            };
        },
        importData: function(serverData){
            var leStore = this;
            var serverLevelData = serverData.conclusion;
            if(!serverLevelData){
                serverLevelData = {};
            }
            leStore.setLevel('ranks', serverLevelData.detection_rank);
            leStore.setLevel('costs', serverLevelData.detection_cost);
            leStore.saveRemark(serverLevelData.detection_conclusion_comment);
        }
    }
});