AuctionTypein.factory('DataService', function ($http) {
    return {
        pai_data:{
            auction: {
                "open_price": "",                              // 起拍价
                "reserve_price": "",                           // 保留价
                "others": "" ,                         // 竞拍的其他说明
                "p_seller":"",
                personal_seller: {
                    "name": "",
                    "mobile": "",
                    "bank": "",
                    "bank_code": "",
                    "bank_owner_name": ""
                }
            }

        },
        pics_uploaded:[],//每次保存后，成功上传的图片的本地路径集合
        carType:1, //车辆类型，0 全新车 1 二手车
        paiType:"", //拍卖类型 0 实时拍 1 现场拍
		basic_data:{basic:{},procedure:{},configuration:{}},
        pic_data:[],
        detection_data:{

        },
		getObjectLength: function(obj){
			var num = 0;
			for(var i in obj){
				num++;
			}
			return num;
		},
        //获取检测信息数据
        getDetectData:function(){
            var DEDA = window.detectionData;
            var detectionData = this.detection_data


            var totalCount = 0, filled = 0;
            var detectTabs = DEDA.getTabs();
            detectTabs.forEach(function(tab){
                var groups = DEDA.getGroups(tab.name);
                var tabItems = DEDA.getItems(tab.name);

                if(groups){
                    var tabResult = {};
                    groups.forEach(function(group){
                        var groupData = detectionData[group.name];
                        if(groupData){
                            tabResult = $.extend(true, tabResult, groupData);
                        }
                    });
                    tabItems.forEach(function(item, index){
                        totalCount++;

                        var itemVal = tabResult[item.dataKey];
                        if(itemVal && (itemVal.detection || itemVal.other)){
                            filled++;
                        }
                    });
                }
                else{
                    var tabResult = detectionData[tab.name];

                    if(!tabResult){
                    }
                    tabItems.forEach(function(item, index){
                        // 计总数
                        totalCount++;
                        if(!tabResult){
                            return;
                        }
                        var itemVal = tabResult[item.dataKey];
                        if(itemVal && (itemVal.detection || itemVal.other)){
                            filled++;
                        }
                        else{
                        }
                    });
                }
            });

            var conclusionData = this.detection_data.conclusion || {};
            var description = undefined;
            if(filled === 0){
                description = '未填写';
            }
            else{
                if(filled === totalCount){
                    if(conclusionData.detection_rank && conclusionData.detection_cost){
                        description = '已完成';
                    }
                    else{
                        description = '未评级';
                    }
                }
            }

            return {
                data:$.extend(true,{},this.detection_data),
                total_count: totalCount, //总数
                type_count: filled, //填写项数
                description: description
            };
        },
        setDetectData:function(detectData){
            this.detection_data = $.extend(true, this.detection_data, detectData);
        },
        setLevelData:function(levelData){
            this.detection_data.conclusion = $.extend(true, {}, levelData);
        },
        //获取基本信息数据,basic,procedure,configuration 三部分
        getBasicData:function() {
            var that = this;
			var type_count = 0;
			var total_count = (parseInt(this.carType) === 0) ? 39 : 17;
			var carInfoData = this.basic_data;
            var baseKeyArr = [
                'vin_code',
                'model',
                'vehicle_attribution_province_id',
                'vehicle_attribution_city_id',
                'engine_capacity',
                'environment',
                'mileage',
                'color',
                'use_nature',
                'manufacture_date',
                'begin_at',
                'original_price',
                'price',
                'pifa_price'
            ];
            var procedureKeyArr = [
                'year_insurance',
                'compulsory_insurance'
            ];
            var configurationKeyArr = [
                'variable_form'
            ]

            addTypecount(carInfoData.basic, baseKeyArr);
            addTypecount(carInfoData.procedure, procedureKeyArr);
            addTypecount(carInfoData.configuration, configurationKeyArr);

            function addTypecount(carInfoDataProp,keyArr){
                if(carInfoDataProp){
                    for(var j=0; j<keyArr.length; j++){
                        var key = keyArr[j];
                        if(carInfoDataProp[key] != null){
                            type_count++;
                        }
                    }
                }
            }

            var result = $.extend(true,{},carInfoData);
            //moment(result.basic.begin_at*1000).format("YYYY-MM-DD")
            console.log(result);
            return {
                data: result,
                total_count: total_count, //总数
                type_count:type_count //填写项数
            };
        },
		setBasicData:function(carInfoData){
			this.basic_data = $.extend(true,{},carInfoData)
		},
        setCommentData: function(comment){
            console.log(comment, this.basic_data);
            this.basic_data = $.extend(true, this.basic_data, { basic: { others: comment } });
        },
        getCommentData: function(){
            console.log(this.basic_data.basic.others)
            return this.basic_data.basic.others;
        },
        //获取拍卖信息数据
        getPaiData:function(){
            var result = {};
            var total_count = 3;
            var type_count = 0;
            if(this.pai_data.auction){
                this.pai_data.is_daipai = 0;
                if(this.pai_data.personal_seller){
                    for(var i in this.pai_data.personal_seller){
                        if(this.pai_data.personal_seller[i]){
                            this.pai_data.is_daipai = 1;
                        }
                    }
                }
                for(var i in this.pai_data.auction){
                    if(i=="personal_seller"||i=="others"){

                    }else if(i=="contact_mobile"){

                    }else
                    if(this.pai_data.auction[i]!==""&&this.pai_data.auction[i]!==null){
                        type_count++;
                    }
                }
//                result.auction_type = this.paiType;
            }
            return {
                data: $.extend(true,{},this.pai_data), //最终的数据，与api相对
                total_count:total_count, //总数
                type_count:type_count //填写项数
            }
        },
        setPaiData:function(_data){
            this.pai_data = $.extend(true,{},_data);
        },
        getPicData:function(){
            var arr = [];
            this.pic_data.forEach(function(i){
                arr.push(i)
            })
            return {
                data:arr,
                type_count:this.pic_data.length
            };
        },
        setPicData:function(pics){
            var arr = [];
            pics.forEach(function(i){
                if(i&&arr.indexOf(i)==-1)
                    arr.push(i)
            })
            this.pic_data = arr
        }

    }

});
