AuctionTypein.factory('NetService', function ($http) {
   var base_url = "http://niu.souche.com";
   if(window.h5_is_dev){
     var base_url = "http://cheniu-dev.souche.com:8001"
   }
    return {
        converArrayToJson: function(arr){
            var dataJson=[];
            $.each(arr, function(index, val){
                dataJson[index] = {};
                dataJson[index].name = val[0];
                dataJson[index].code = val[1];
            })
            return dataJson;
        },
        getProvince:function(callback){
            var self=this;
            $http.get('http://crm.souche.com/provinces.json').success(function(response){
                var data=self.converArrayToJson(response.data)

                callback(data);
            })
        },
        getCity:function(id, callback){
            var self=this;
            $http.get('http://crm.souche.com/provinces/' + id+ '/cities.json').success(function(response){
                var data=self.converArrayToJson(response.data)
                callback(data);
            })
        },
        getCityG:function(id, callback){
            var self=this;
            $http.get('http://crm.souche.com/provinces/' + id+ '/cities.json').success(function(response){
                var data=self.converArrayToJson(response.data)
                callback(data);
            })
        },
		//conver unit when restore data
		convertUnitToWan: function (object, key) {
			if (object && object[key]) {
				object[key] = (object[key]*1)/10000 ;
			}
		},
		//conver unit to Yuan when save data
		convertUnitToYuan: function (object, key) {
			if (object && object[key]) {
				object[key] = Math.round(object[key]*10000) ;
			}
		},
        saveToOnline:function(result,isReview,callback){
            var token = UserInfo.token;
            $.ajax({
                url:base_url+(result.orderId?'/detection/save':"/detection/order/createByDetection")+"?token="+token,
                data:{
                    param:JSON.stringify(result),
                    status:isReview?5:4,
                    id:result.id
                },
                type:"post",
                dataType:"json",
                success:function(data){
                    if(data.resultId==0){
                        callback(null,data)
                    }else{
                        callback(new Error(data.message),data)
                    }
                },
                error:function(e){
                    callback(new Error("网络出错，请稍后重试！"))
                }
            })
        },
        restoreFromOnline:function(carId,callback){
           var token = UserInfo.token;
            $.ajax({
                url:base_url+"/detection/fetch/"+carId+"?token="+token,
                type:"get",
                dataType:"json",
                success:function(data){
                    if(data.status==200){
                        callback(null,data.data)
                    }else{
                        callback(new Error(data.message),data)
                    }

                },
                error:function(e){
                    callback(new Error("网络出错，请稍后重试！"))
                }
            })
        },
        //上传图片，返回一个本地url:线上url的json
        savePics:function(pics,callback){
            if((!pics)||(!pics.length)){
                callback({})
                return
            }
            if(window.CheNiu){
                CheNiu.uploadFilesCallback=function(str){
                    var ps = str.split(",")
                    var r = {}
                    ps.forEach(function(p){
                        var s = p.split("=")
                        if(s.length){
                            r[s[0]]=s[1];
                        }
                    })
                    callback(r)
                };
                CheNiu.uploadFiles(pics.join(","))
            }else{
                var obj = {};
                pics.forEach(function(p){
                    obj[p] = ""
                })
                callback(obj)
            }
        },
        submitReview:function(result,callback){
            var token = UserInfo.token;
            $.ajax({
                url:base_url+"/detection/order/createByDetection?token="+token,
                data:{
                    param:JSON.stringify(result),
                    status:5,
                    id:result.id
                },
                type:"post",
                dataType:"json",
                success:function(data){
                    if(data.status==200){
                        callback(null,data)
                    }else{
                        callback(new Error(data.message),data)
                    }
                },
                error:function(e){
                    callback(new Error("网络出错，请稍后重试！"))
                }
            })
        },
        getInfoByVIN:function(vin,callback){
            //LFV4A24F3B3078582
            $.ajax({
                url:"http://manage.souche.com/pages/vinAction/vin.json?vin="+vin,
                type:"get",
                dataType:"json",
                timeout:5000,
                success:function(data){
                    if(data&&data.length){
                        callback(null,data)
                    }else{
                        callback(new Error("vin格式错误"))
                    }
                },
                error:function(e){
                    callback(new Error("网络出错，请稍后重试！"))
                }
            })
        },
        getConfigByModel: function(modelCode, callback){
            var url = 'http://42.120.61.109/model/parameter/m/';
            $.ajax({
                url: url + modelCode,
                type:"get",
                dataType:"jsonp",
                timeout:5000,
                success:function(data){
                    if(data&&data.data&&data.code === 200){
                        callback(null, data.data)
                    }else{
                        var errorMsg = {
                            403: '车型不存在',
                            101: '参数不能为空'
                        };
                        callback(new Error( errorMsg[data.code] || '未知错误'))
                    }
                },
                error:function(e){
                    callback(new Error("网络出错，请稍后重试！"))
                }
            })
        }
    }
});
